﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Services;
using System.Data;

namespace OThinker.H3.Portal
{
    /// <summary>
    ///WebService 的摘要说明
    /// </summary>
    [WebService(Namespace = "http://tempuri.org/")]
    [WebServiceBinding(ConformsTo = WsiProfiles.BasicProfile1_1)]
    //若要允许使用 ASP.NET AJAX 从脚本中调用此 Web 服务，请取消对下行的注释。 
    // [System.Web.Script.Services.ScriptService]
    public class WebService : System.Web.Services.WebService
    {

        public WebService()
        {

            //如果使用设计的组件，请取消注释以下行 
            //InitializeComponent(); 
        }

        private IEngine _Engine = null;
        /// <summary>
        /// 流程引擎的接口，该接口会比this.Engine的方式更快，因为其中使用了缓存
        /// </summary>
        public IEngine Engine
        {
            get
            {
                if (OThinker.H3.WorkSheet.AppConfig.ConnectionMode == ConnectionStringParser.ConnectionMode.Mono)
                {
                    return OThinker.H3.WorkSheet.AppUtility.Engine;
                }
                return _Engine;
            }
            set
            {
                _Engine = value;
            }
        }

        [WebMethod]
        public string HelloWorld()
        {
            return "Hello World";
        }

        [WebMethod]
        public List<string> Year()
        {
            List<string> list = new List<string>();
            list.Add(DateTime.Now.ToString("yyyy"));
            list.Add(DateTime.Now.AddYears(1).ToString("yyyy"));
            list.Add(DateTime.Now.AddYears(2).ToString("yyyy"));
            return list;
        }
        /// <summary>
        /// 获取对应二级部门ID ，预算只预算到二级部门，报销需要能够报销到具体的部门，报销时需要往上查找对应的二级部门去计算预算情况
        /// </summary>
        /// <param name="deptId">部门ID</param>
        /// <returns></returns>
        private string GetSecondDept(string deptId)
        {
            //查找二级部门
            string twoParent = OThinker.H3.WorkSheet.AppUtility.Engine.Organization.GetParentByLevel(deptId, 2);

            //判断本身是不是二级部门，如果本身是二级部门则twoParent为一级部门，判断twoParent的父级部门是不是公司即可
            OThinker.Organization.OrganizationUnit u = OThinker.H3.WorkSheet.AppUtility.Engine.Organization.GetUnit(twoParent) as OThinker.Organization.OrganizationUnit;
            string companyId = OThinker.H3.WorkSheet.AppUtility.Engine.Organization.Company.CompanyID;

            if (u != null && u.ParentID == companyId)
            {
                return deptId;
            }

            return twoParent;
        }

        /// <summary>
        /// 增加预算
        /// </summary>
        /// <param name="instanceId"></param>
        [WebMethod]
        public void SetBudgetFinal(string instanceId)
        {
            DataTable dt = new DataTable();
            string sqltext = "select a.DeptName,a.DeptCode,a.CostType,a.BudgetType,a.January,a.February,a.March,a.April,a.May,a.June,a.July,a.August,a.September,a.October,a.November,a.December,a.Total,b.DSFDepartment,b.Year,b.CreatedBy,c.ObjectID from I_DSFBudget a inner join I_BudgetManage b on a.ParentObjectID=b.ObjectID inner join OT_InstanceContext c on b.ObjectID=c.BizObjectId  where c.ObjectID='{0}'";
            sqltext = string.Format(sqltext, instanceId);
            dt = OThinker.H3.WorkSheet.AppUtility.Engine.EngineConfig.CommandFactory.CreateCommand().ExecuteDataTable(sqltext);
            if (dt != null && dt.Rows.Count > 0)
            {
                for (int i = 0; i < dt.Rows.Count; i++)
                {
                    for (int j = 1; j <= 12; j++)
                    {
                        #region 写入预算
                        switch (j)
                        {
                            case 1:
                                string sqlInsert = @"INSERT INTO [DSF_Budget_FinalPayment]
                                       ([ObjectID]
                                       ,[ParentObjectID]
                                       ,[ParentPropertyName]
                                       ,[ParentIndex]
                                       ,[InstanceId]
                                       ,[Year]
                                       ,[Month]
                                       ,[UnitID]
                                       ,[UnitName]
                                       ,[MainSbjCode]
                                       ,[SubSbjCode]
                                       ,[SubjectCode]
                                       ,[Amount]
                                       ,[YearAmount]
                                       ,[YearRestAmount]
                                       ,[MonthAmount]
                                       ,[MonthRestAmount]
                                       ,[State]
                                       ,[CreatedTime]
                                       ,[CreatedBy]
                                       ,[ModifiedTime]
                                       ,[ModifiedBy])
                                 VALUES
                                       ('{0}'
                                       ,''
                                       ,''
                                       ,0
                                       ,'{1}'
                                       ,{2}
                                       ,{3}
                                       ,'{4}'
                                       ,'{5}'
                                       ,'{6}'
                                       ,''
                                       ,''
                                       ,0
                                       ,{8}
                                       ,{8}
                                       ,{7}
                                       ,{7}
                                       ,1
                                       ,getdate()
                                       ,'{9}'
                                       ,getdate()
                                       ,'{10}')";
                                sqlInsert = string.Format(sqlInsert, Guid.NewGuid(), dt.Rows[i]["ObjectID"].ToString(), dt.Rows[i]["Year"].ToString(), "1", dt.Rows[i]["DeptCode"].ToString(), dt.Rows[i]["DeptName"].ToString(), dt.Rows[i]["CostType"].ToString(), dt.Rows[i]["January"].ToString(), dt.Rows[i]["Total"].ToString(), dt.Rows[i]["CreatedBy"].ToString(), dt.Rows[i]["CreatedBy"].ToString());
                                OThinker.H3.WorkSheet.AppUtility.Engine.EngineConfig.CommandFactory.CreateCommand().ExecuteNonQuery(sqlInsert);
                                break;
                            case 2:
                                sqlInsert = @"INSERT INTO [DSF_Budget_FinalPayment]
                                       ([ObjectID]
                                       ,[ParentObjectID]
                                       ,[ParentPropertyName]
                                       ,[ParentIndex]
                                       ,[InstanceId]
                                       ,[Year]
                                       ,[Month]
                                       ,[UnitID]
                                       ,[UnitName]
                                       ,[MainSbjCode]
                                       ,[SubSbjCode]
                                       ,[SubjectCode]
                                       ,[Amount]
                                       ,[YearAmount]
                                       ,[YearRestAmount]
                                       ,[MonthAmount]
                                       ,[MonthRestAmount]
                                       ,[State]
                                       ,[CreatedTime]
                                       ,[CreatedBy]
                                       ,[ModifiedTime]
                                       ,[ModifiedBy])
                                 VALUES
                                       ('{0}'
                                       ,''
                                       ,''
                                       ,0
                                       ,'{1}'
                                       ,{2}
                                       ,{3}
                                       ,'{4}'
                                       ,'{5}'
                                       ,'{6}'
                                       ,''
                                       ,''
                                       ,0
                                       ,{8}
                                       ,{8}
                                       ,{7}
                                       ,{7}
                                       ,1
                                       ,getdate()
                                       ,'{9}'
                                       ,getdate()
                                       ,'{10}')";
                                sqlInsert = string.Format(sqlInsert, Guid.NewGuid(), dt.Rows[i]["ObjectID"].ToString(), dt.Rows[i]["Year"].ToString(), "2", dt.Rows[i]["DeptCode"].ToString(), dt.Rows[i]["DeptName"].ToString(), dt.Rows[i]["CostType"].ToString(), dt.Rows[i]["February"].ToString(), dt.Rows[i]["Total"].ToString(), dt.Rows[i]["CreatedBy"].ToString(), dt.Rows[i]["CreatedBy"].ToString());
                                OThinker.H3.WorkSheet.AppUtility.Engine.EngineConfig.CommandFactory.CreateCommand().ExecuteNonQuery(sqlInsert);
                                break;
                            case 3:
                                sqlInsert = @"INSERT INTO [DSF_Budget_FinalPayment]
                                       ([ObjectID]
                                       ,[ParentObjectID]
                                       ,[ParentPropertyName]
                                       ,[ParentIndex]
                                       ,[InstanceId]
                                       ,[Year]
                                       ,[Month]
                                       ,[UnitID]
                                       ,[UnitName]
                                       ,[MainSbjCode]
                                       ,[SubSbjCode]
                                       ,[SubjectCode]
                                       ,[Amount]
                                       ,[YearAmount]
                                       ,[YearRestAmount]
                                       ,[MonthAmount]
                                       ,[MonthRestAmount]
                                       ,[State]
                                       ,[CreatedTime]
                                       ,[CreatedBy]
                                       ,[ModifiedTime]
                                       ,[ModifiedBy])
                                 VALUES
                                       ('{0}'
                                       ,''
                                       ,''
                                       ,0
                                       ,'{1}'
                                       ,{2}
                                       ,{3}
                                       ,'{4}'
                                       ,'{5}'
                                       ,'{6}'
                                       ,''
                                       ,''
                                       ,0
                                       ,{8}
                                       ,{8}
                                       ,{7}
                                       ,{7}
                                       ,1
                                       ,getdate()
                                       ,'{9}'
                                       ,getdate()
                                       ,'{10}')";
                                sqlInsert = string.Format(sqlInsert, Guid.NewGuid(), dt.Rows[i]["ObjectID"].ToString(), dt.Rows[i]["Year"].ToString(), "3", dt.Rows[i]["DeptCode"].ToString(), dt.Rows[i]["DeptName"].ToString(), dt.Rows[i]["CostType"].ToString(), dt.Rows[i]["March"].ToString(), dt.Rows[i]["Total"].ToString(), dt.Rows[i]["CreatedBy"].ToString(), dt.Rows[i]["CreatedBy"].ToString());
                                OThinker.H3.WorkSheet.AppUtility.Engine.EngineConfig.CommandFactory.CreateCommand().ExecuteNonQuery(sqlInsert);
                                break;
                            case 4:
                                sqlInsert = @"INSERT INTO [DSF_Budget_FinalPayment]
                                       ([ObjectID]
                                       ,[ParentObjectID]
                                       ,[ParentPropertyName]
                                       ,[ParentIndex]
                                       ,[InstanceId]
                                       ,[Year]
                                       ,[Month]
                                       ,[UnitID]
                                       ,[UnitName]
                                       ,[MainSbjCode]
                                       ,[SubSbjCode]
                                       ,[SubjectCode]
                                       ,[Amount]
                                       ,[YearAmount]
                                       ,[YearRestAmount]
                                       ,[MonthAmount]
                                       ,[MonthRestAmount]
                                       ,[State]
                                       ,[CreatedTime]
                                       ,[CreatedBy]
                                       ,[ModifiedTime]
                                       ,[ModifiedBy])
                                 VALUES
                                       ('{0}'
                                       ,''
                                       ,''
                                       ,0
                                       ,'{1}'
                                       ,{2}
                                       ,{3}
                                       ,'{4}'
                                       ,'{5}'
                                       ,'{6}'
                                       ,''
                                       ,''
                                       ,0
                                       ,{8}
                                       ,{8}
                                       ,{7}
                                       ,{7}
                                       ,1
                                       ,getdate()
                                       ,'{9}'
                                       ,getdate()
                                       ,'{10}')";
                                sqlInsert = string.Format(sqlInsert, Guid.NewGuid(), dt.Rows[i]["ObjectID"].ToString(), dt.Rows[i]["Year"].ToString(), "4", dt.Rows[i]["DeptCode"].ToString(), dt.Rows[i]["DeptName"].ToString(), dt.Rows[i]["CostType"].ToString(), dt.Rows[i]["April"].ToString(), dt.Rows[i]["Total"].ToString(), dt.Rows[i]["CreatedBy"].ToString(), dt.Rows[i]["CreatedBy"].ToString());
                                OThinker.H3.WorkSheet.AppUtility.Engine.EngineConfig.CommandFactory.CreateCommand().ExecuteNonQuery(sqlInsert);
                                break;
                            case 5:
                                sqlInsert = @"INSERT INTO [DSF_Budget_FinalPayment]
                                       ([ObjectID]
                                       ,[ParentObjectID]
                                       ,[ParentPropertyName]
                                       ,[ParentIndex]
                                       ,[InstanceId]
                                       ,[Year]
                                       ,[Month]
                                       ,[UnitID]
                                       ,[UnitName]
                                       ,[MainSbjCode]
                                       ,[SubSbjCode]
                                       ,[SubjectCode]
                                       ,[Amount]
                                       ,[YearAmount]
                                       ,[YearRestAmount]
                                       ,[MonthAmount]
                                       ,[MonthRestAmount]
                                       ,[State]
                                       ,[CreatedTime]
                                       ,[CreatedBy]
                                       ,[ModifiedTime]
                                       ,[ModifiedBy])
                                 VALUES
                                       ('{0}'
                                       ,''
                                       ,''
                                       ,0
                                       ,'{1}'
                                       ,{2}
                                       ,{3}
                                       ,'{4}'
                                       ,'{5}'
                                       ,'{6}'
                                       ,''
                                       ,''
                                       ,0
                                       ,{8}
                                       ,{8}
                                       ,{7}
                                       ,{7}
                                       ,1
                                       ,getdate()
                                       ,'{9}'
                                       ,getdate()
                                       ,'{10}')";
                                sqlInsert = string.Format(sqlInsert, Guid.NewGuid(), dt.Rows[i]["ObjectID"].ToString(), dt.Rows[i]["Year"].ToString(), "5", dt.Rows[i]["DeptCode"].ToString(), dt.Rows[i]["DeptName"].ToString(), dt.Rows[i]["CostType"].ToString(), dt.Rows[i]["May"].ToString(), dt.Rows[i]["Total"].ToString(), dt.Rows[i]["CreatedBy"].ToString(), dt.Rows[i]["CreatedBy"].ToString());
                                OThinker.H3.WorkSheet.AppUtility.Engine.EngineConfig.CommandFactory.CreateCommand().ExecuteNonQuery(sqlInsert);
                                break;
                            case 6:
                                sqlInsert = @"INSERT INTO [DSF_Budget_FinalPayment]
                                       ([ObjectID]
                                       ,[ParentObjectID]
                                       ,[ParentPropertyName]
                                       ,[ParentIndex]
                                       ,[InstanceId]
                                       ,[Year]
                                       ,[Month]
                                       ,[UnitID]
                                       ,[UnitName]
                                       ,[MainSbjCode]
                                       ,[SubSbjCode]
                                       ,[SubjectCode]
                                       ,[Amount]
                                       ,[YearAmount]
                                       ,[YearRestAmount]
                                       ,[MonthAmount]
                                       ,[MonthRestAmount]
                                       ,[State]
                                       ,[CreatedTime]
                                       ,[CreatedBy]
                                       ,[ModifiedTime]
                                       ,[ModifiedBy])
                                 VALUES
                                       ('{0}'
                                       ,''
                                       ,''
                                       ,0
                                       ,'{1}'
                                       ,{2}
                                       ,{3}
                                       ,'{4}'
                                       ,'{5}'
                                       ,'{6}'
                                       ,''
                                       ,''
                                       ,0
                                       ,{8}
                                       ,{8}
                                       ,{7}
                                       ,{7}
                                       ,1
                                       ,getdate()
                                       ,'{9}'
                                       ,getdate()
                                       ,'{10}')";
                                sqlInsert = string.Format(sqlInsert, Guid.NewGuid(), dt.Rows[i]["ObjectID"].ToString(), dt.Rows[i]["Year"].ToString(), "6", dt.Rows[i]["DeptCode"].ToString(), dt.Rows[i]["DeptName"].ToString(), dt.Rows[i]["CostType"].ToString(), dt.Rows[i]["June"].ToString(), dt.Rows[i]["Total"].ToString(), dt.Rows[i]["CreatedBy"].ToString(), dt.Rows[i]["CreatedBy"].ToString());
                                OThinker.H3.WorkSheet.AppUtility.Engine.EngineConfig.CommandFactory.CreateCommand().ExecuteNonQuery(sqlInsert);
                                break;
                            case 7:
                                sqlInsert = @"INSERT INTO [DSF_Budget_FinalPayment]
                                       ([ObjectID]
                                       ,[ParentObjectID]
                                       ,[ParentPropertyName]
                                       ,[ParentIndex]
                                       ,[InstanceId]
                                       ,[Year]
                                       ,[Month]
                                       ,[UnitID]
                                       ,[UnitName]
                                       ,[MainSbjCode]
                                       ,[SubSbjCode]
                                       ,[SubjectCode]
                                       ,[Amount]
                                       ,[YearAmount]
                                       ,[YearRestAmount]
                                       ,[MonthAmount]
                                       ,[MonthRestAmount]
                                       ,[State]
                                       ,[CreatedTime]
                                       ,[CreatedBy]
                                       ,[ModifiedTime]
                                       ,[ModifiedBy])
                                 VALUES
                                       ('{0}'
                                       ,''
                                       ,''
                                       ,0
                                       ,'{1}'
                                       ,{2}
                                       ,{3}
                                       ,'{4}'
                                       ,'{5}'
                                       ,'{6}'
                                       ,''
                                       ,''
                                       ,0
                                       ,{8}
                                       ,{8}
                                       ,{7}
                                       ,{7}
                                       ,1
                                       ,getdate()
                                       ,'{9}'
                                       ,getdate()
                                       ,'{10}')";
                                sqlInsert = string.Format(sqlInsert, Guid.NewGuid(), dt.Rows[i]["ObjectID"].ToString(), dt.Rows[i]["Year"].ToString(), "7", dt.Rows[i]["DeptCode"].ToString(), dt.Rows[i]["DeptName"].ToString(), dt.Rows[i]["CostType"].ToString(), dt.Rows[i]["July"].ToString(), dt.Rows[i]["Total"].ToString(), dt.Rows[i]["CreatedBy"].ToString(), dt.Rows[i]["CreatedBy"].ToString());
                                OThinker.H3.WorkSheet.AppUtility.Engine.EngineConfig.CommandFactory.CreateCommand().ExecuteNonQuery(sqlInsert);
                                break;
                            case 8:
                                sqlInsert = @"INSERT INTO [DSF_Budget_FinalPayment]
                                       ([ObjectID]
                                       ,[ParentObjectID]
                                       ,[ParentPropertyName]
                                       ,[ParentIndex]
                                       ,[InstanceId]
                                       ,[Year]
                                       ,[Month]
                                       ,[UnitID]
                                       ,[UnitName]
                                       ,[MainSbjCode]
                                       ,[SubSbjCode]
                                       ,[SubjectCode]
                                       ,[Amount]
                                       ,[YearAmount]
                                       ,[YearRestAmount]
                                       ,[MonthAmount]
                                       ,[MonthRestAmount]
                                       ,[State]
                                       ,[CreatedTime]
                                       ,[CreatedBy]
                                       ,[ModifiedTime]
                                       ,[ModifiedBy])
                                 VALUES
                                       ('{0}'
                                       ,''
                                       ,''
                                       ,0
                                       ,'{1}'
                                       ,{2}
                                       ,{3}
                                       ,'{4}'
                                       ,'{5}'
                                       ,'{6}'
                                       ,''
                                       ,''
                                       ,0
                                       ,{8}
                                       ,{8}
                                       ,{7}
                                       ,{7}
                                       ,1
                                       ,getdate()
                                       ,'{9}'
                                       ,getdate()
                                       ,'{10}')";
                                sqlInsert = string.Format(sqlInsert, Guid.NewGuid(), dt.Rows[i]["ObjectID"].ToString(), dt.Rows[i]["Year"].ToString(), "8", dt.Rows[i]["DeptCode"].ToString(), dt.Rows[i]["DeptName"].ToString(), dt.Rows[i]["CostType"].ToString(), dt.Rows[i]["August"].ToString(), dt.Rows[i]["Total"].ToString(), dt.Rows[i]["CreatedBy"].ToString(), dt.Rows[i]["CreatedBy"].ToString());
                                OThinker.H3.WorkSheet.AppUtility.Engine.EngineConfig.CommandFactory.CreateCommand().ExecuteNonQuery(sqlInsert);
                                break;
                            case 9:
                                sqlInsert = @"INSERT INTO [DSF_Budget_FinalPayment]
                                       ([ObjectID]
                                       ,[ParentObjectID]
                                       ,[ParentPropertyName]
                                       ,[ParentIndex]
                                       ,[InstanceId]
                                       ,[Year]
                                       ,[Month]
                                       ,[UnitID]
                                       ,[UnitName]
                                       ,[MainSbjCode]
                                       ,[SubSbjCode]
                                       ,[SubjectCode]
                                       ,[Amount]
                                       ,[YearAmount]
                                       ,[YearRestAmount]
                                       ,[MonthAmount]
                                       ,[MonthRestAmount]
                                       ,[State]
                                       ,[CreatedTime]
                                       ,[CreatedBy]
                                       ,[ModifiedTime]
                                       ,[ModifiedBy])
                                 VALUES
                                       ('{0}'
                                       ,''
                                       ,''
                                       ,0
                                       ,'{1}'
                                       ,{2}
                                       ,{3}
                                       ,'{4}'
                                       ,'{5}'
                                       ,'{6}'
                                       ,''
                                       ,''
                                       ,0
                                       ,{8}
                                       ,{8}
                                       ,{7}
                                       ,{7}
                                       ,1
                                       ,getdate()
                                       ,'{9}'
                                       ,getdate()
                                       ,'{10}')";
                                sqlInsert = string.Format(sqlInsert, Guid.NewGuid(), dt.Rows[i]["ObjectID"].ToString(), dt.Rows[i]["Year"].ToString(), "9", dt.Rows[i]["DeptCode"].ToString(), dt.Rows[i]["DeptName"].ToString(), dt.Rows[i]["CostType"].ToString(), dt.Rows[i]["September"].ToString(), dt.Rows[i]["Total"].ToString(), dt.Rows[i]["CreatedBy"].ToString(), dt.Rows[i]["CreatedBy"].ToString());
                                OThinker.H3.WorkSheet.AppUtility.Engine.EngineConfig.CommandFactory.CreateCommand().ExecuteNonQuery(sqlInsert);
                                break;
                            case 10:
                                sqlInsert = @"INSERT INTO [DSF_Budget_FinalPayment]
                                       ([ObjectID]
                                       ,[ParentObjectID]
                                       ,[ParentPropertyName]
                                       ,[ParentIndex]
                                       ,[InstanceId]
                                       ,[Year]
                                       ,[Month]
                                       ,[UnitID]
                                       ,[UnitName]
                                       ,[MainSbjCode]
                                       ,[SubSbjCode]
                                       ,[SubjectCode]
                                       ,[Amount]
                                       ,[YearAmount]
                                       ,[YearRestAmount]
                                       ,[MonthAmount]
                                       ,[MonthRestAmount]
                                       ,[State]
                                       ,[CreatedTime]
                                       ,[CreatedBy]
                                       ,[ModifiedTime]
                                       ,[ModifiedBy])
                                 VALUES
                                       ('{0}'
                                       ,''
                                       ,''
                                       ,0
                                       ,'{1}'
                                       ,{2}
                                       ,{3}
                                       ,'{4}'
                                       ,'{5}'
                                       ,'{6}'
                                       ,''
                                       ,''
                                       ,0
                                       ,{8}
                                       ,{8}
                                       ,{7}
                                       ,{7}
                                       ,1
                                       ,getdate()
                                       ,'{9}'
                                       ,getdate()
                                       ,'{10}')";
                                sqlInsert = string.Format(sqlInsert, Guid.NewGuid(), dt.Rows[i]["ObjectID"].ToString(), dt.Rows[i]["Year"].ToString(), "10", dt.Rows[i]["DeptCode"].ToString(), dt.Rows[i]["DeptName"].ToString(), dt.Rows[i]["CostType"].ToString(), dt.Rows[i]["October"].ToString(), dt.Rows[i]["Total"].ToString(), dt.Rows[i]["CreatedBy"].ToString(), dt.Rows[i]["CreatedBy"].ToString());
                                OThinker.H3.WorkSheet.AppUtility.Engine.EngineConfig.CommandFactory.CreateCommand().ExecuteNonQuery(sqlInsert);
                                break;
                            case 11:
                                sqlInsert = @"INSERT INTO [DSF_Budget_FinalPayment]
                                       ([ObjectID]
                                       ,[ParentObjectID]
                                       ,[ParentPropertyName]
                                       ,[ParentIndex]
                                       ,[InstanceId]
                                       ,[Year]
                                       ,[Month]
                                       ,[UnitID]
                                       ,[UnitName]
                                       ,[MainSbjCode]
                                       ,[SubSbjCode]
                                       ,[SubjectCode]
                                       ,[Amount]
                                       ,[YearAmount]
                                       ,[YearRestAmount]
                                       ,[MonthAmount]
                                       ,[MonthRestAmount]
                                       ,[State]
                                       ,[CreatedTime]
                                       ,[CreatedBy]
                                       ,[ModifiedTime]
                                       ,[ModifiedBy])
                                 VALUES
                                       ('{0}'
                                       ,''
                                       ,''
                                       ,0
                                       ,'{1}'
                                       ,{2}
                                       ,{3}
                                       ,'{4}'
                                       ,'{5}'
                                       ,'{6}'
                                       ,''
                                       ,''
                                       ,0
                                       ,{8}
                                       ,{8}
                                       ,{7}
                                       ,{7}
                                       ,1
                                       ,getdate()
                                       ,'{9}'
                                       ,getdate()
                                       ,'{10}')";
                                sqlInsert = string.Format(sqlInsert, Guid.NewGuid(), dt.Rows[i]["ObjectID"].ToString(), dt.Rows[i]["Year"].ToString(), "11", dt.Rows[i]["DeptCode"].ToString(), dt.Rows[i]["DeptName"].ToString(), dt.Rows[i]["CostType"].ToString(), dt.Rows[i]["November"].ToString(), dt.Rows[i]["Total"].ToString(), dt.Rows[i]["CreatedBy"].ToString(), dt.Rows[i]["CreatedBy"].ToString());
                                OThinker.H3.WorkSheet.AppUtility.Engine.EngineConfig.CommandFactory.CreateCommand().ExecuteNonQuery(sqlInsert);
                                break;
                            case 12:
                                sqlInsert = @"INSERT INTO [DSF_Budget_FinalPayment]
                                       ([ObjectID]
                                       ,[ParentObjectID]
                                       ,[ParentPropertyName]
                                       ,[ParentIndex]
                                       ,[InstanceId]
                                       ,[Year]
                                       ,[Month]
                                       ,[UnitID]
                                       ,[UnitName]
                                       ,[MainSbjCode]
                                       ,[SubSbjCode]
                                       ,[SubjectCode]
                                       ,[Amount]
                                       ,[YearAmount]
                                       ,[YearRestAmount]
                                       ,[MonthAmount]
                                       ,[MonthRestAmount]
                                       ,[State]
                                       ,[CreatedTime]
                                       ,[CreatedBy]
                                       ,[ModifiedTime]
                                       ,[ModifiedBy])
                                 VALUES
                                       ('{0}'
                                       ,''
                                       ,''
                                       ,0
                                       ,'{1}'
                                       ,{2}
                                       ,{3}
                                       ,'{4}'
                                       ,'{5}'
                                       ,'{6}'
                                       ,''
                                       ,''
                                       ,0
                                       ,{8}
                                       ,{8}
                                       ,{7}
                                       ,{7}
                                       ,1
                                       ,getdate()
                                       ,'{9}'
                                       ,getdate()
                                       ,'{10}')";
                                sqlInsert = string.Format(sqlInsert, Guid.NewGuid(), dt.Rows[i]["ObjectID"].ToString(), dt.Rows[i]["Year"].ToString(), "12", dt.Rows[i]["DeptCode"].ToString(), dt.Rows[i]["DeptName"].ToString(), dt.Rows[i]["CostType"].ToString(), dt.Rows[i]["December"].ToString(), dt.Rows[i]["Total"].ToString(), dt.Rows[i]["CreatedBy"].ToString(), dt.Rows[i]["CreatedBy"].ToString());
                                OThinker.H3.WorkSheet.AppUtility.Engine.EngineConfig.CommandFactory.CreateCommand().ExecuteNonQuery(sqlInsert);
                                break;
                        }
                        #endregion
                    }
                }
            }
        }

        /// <summary>
        /// 预算调整
        /// </summary>
        /// <param name="instanceId"></param>
        [WebMethod]
        public void AdjustBudgetFinal(string instanceId)
        {
            DataTable dt = new DataTable();
            string sqltext = "select a.DeptName,a.DeptCode,a.CostType,a.BudgetType,a.JanuaryCh,a.FebruaryCh,a.MarchCh,a.AprilCh,a.MayCh,a.JuneCh,a.JulyCh,a.AugustCh,a.SeptemberCh,a.OctoberCh,a.NovemberCh,a.DecemberCh,a.TotalCh,b.DSFDepartment,b.Year,b.CreatedBy,c.ObjectID from I_DSFBudgetAdjust a inner join I_BudgetAdjust b on a.ParentObjectID=b.ObjectID inner join OT_InstanceContext c on b.ObjectID=c.BizObjectId where c.ObjectID='{0}'";
            sqltext = string.Format(sqltext, instanceId);
            dt = OThinker.H3.WorkSheet.AppUtility.Engine.EngineConfig.CommandFactory.CreateCommand().ExecuteDataTable(sqltext);
            if (dt != null && dt.Rows.Count > 0)
            {
                for (int i = 0; i < dt.Rows.Count; i++)
                {
                    string sqlUpdate = "UPDATE DSF_Budget_FinalPayment SET State=0 WHERE UnitID='{0}' AND MainSbjCode='{1}' AND Year='{2}'";
                    sqlUpdate = string.Format(sqlUpdate, dt.Rows[i]["DeptCode"].ToString(), dt.Rows[i]["CostType"].ToString(), dt.Rows[i]["Year"].ToString());
                    OThinker.H3.WorkSheet.AppUtility.Engine.EngineConfig.CommandFactory.CreateCommand().ExecuteNonQuery(sqlUpdate);
                    for (int j = 1; j <= 12; j++)
                    {
                        #region 写入预算
                        switch (j)
                        {
                            case 1:
                                string sqlInsert = @"INSERT INTO [DSF_Budget_FinalPayment]
                                       ([ObjectID]
                                       ,[ParentObjectID]
                                       ,[ParentPropertyName]
                                       ,[ParentIndex]
                                       ,[InstanceId]
                                       ,[Year]
                                       ,[Month]
                                       ,[UnitID]
                                       ,[UnitName]
                                       ,[MainSbjCode]
                                       ,[SubSbjCode]
                                       ,[SubjectCode]
                                       ,[Amount]
                                       ,[YearAmount]
                                       ,[YearRestAmount]
                                       ,[MonthAmount]
                                       ,[MonthRestAmount]
                                       ,[State]
                                       ,[CreatedTime]
                                       ,[CreatedBy]
                                       ,[ModifiedTime]
                                       ,[ModifiedBy])
                                 VALUES
                                       ('{0}'
                                       ,''
                                       ,''
                                       ,0
                                       ,'{1}'
                                       ,{2}
                                       ,{3}
                                       ,'{4}'
                                       ,'{5}'
                                       ,'{6}'
                                       ,''
                                       ,''
                                       ,0
                                       ,{8}
                                       ,{8}
                                       ,{7}
                                       ,{7}
                                       ,1
                                       ,getdate()
                                       ,'{9}'
                                       ,getdate()
                                       ,'{10}')";
                                sqlInsert = string.Format(sqlInsert, Guid.NewGuid(), dt.Rows[i]["ObjectID"].ToString(), dt.Rows[i]["Year"].ToString(), "1", dt.Rows[i]["DeptCode"].ToString(), dt.Rows[i]["DeptName"].ToString(), dt.Rows[i]["CostType"].ToString(), dt.Rows[i]["JanuaryCh"].ToString(), dt.Rows[i]["TotalCh"].ToString(), dt.Rows[i]["CreatedBy"].ToString(), dt.Rows[i]["CreatedBy"].ToString());
                                OThinker.H3.WorkSheet.AppUtility.Engine.EngineConfig.CommandFactory.CreateCommand().ExecuteNonQuery(sqlInsert);
                                break;
                            case 2:
                                sqlInsert = @"INSERT INTO [DSF_Budget_FinalPayment]
                                       ([ObjectID]
                                       ,[ParentObjectID]
                                       ,[ParentPropertyName]
                                       ,[ParentIndex]
                                       ,[InstanceId]
                                       ,[Year]
                                       ,[Month]
                                       ,[UnitID]
                                       ,[UnitName]
                                       ,[MainSbjCode]
                                       ,[SubSbjCode]
                                       ,[SubjectCode]
                                       ,[Amount]
                                       ,[YearAmount]
                                       ,[YearRestAmount]
                                       ,[MonthAmount]
                                       ,[MonthRestAmount]
                                       ,[State]
                                       ,[CreatedTime]
                                       ,[CreatedBy]
                                       ,[ModifiedTime]
                                       ,[ModifiedBy])
                                 VALUES
                                       ('{0}'
                                       ,''
                                       ,''
                                       ,0
                                       ,'{1}'
                                       ,{2}
                                       ,{3}
                                       ,'{4}'
                                       ,'{5}'
                                       ,'{6}'
                                       ,''
                                       ,''
                                       ,0
                                       ,{8}
                                       ,{8}
                                       ,{7}
                                       ,{7}
                                       ,1
                                       ,getdate()
                                       ,'{9}'
                                       ,getdate()
                                       ,'{10}')";
                                sqlInsert = string.Format(sqlInsert, Guid.NewGuid(), dt.Rows[i]["ObjectID"].ToString(), dt.Rows[i]["Year"].ToString(), "2", dt.Rows[i]["DeptCode"].ToString(), dt.Rows[i]["DeptName"].ToString(), dt.Rows[i]["CostType"].ToString(), dt.Rows[i]["JanuaryCh"].ToString(), dt.Rows[i]["TotalCh"].ToString(), dt.Rows[i]["CreatedBy"].ToString(), dt.Rows[i]["CreatedBy"].ToString());
                                OThinker.H3.WorkSheet.AppUtility.Engine.EngineConfig.CommandFactory.CreateCommand().ExecuteNonQuery(sqlInsert);
                                break;
                            case 3:
                                sqlInsert = @"INSERT INTO [DSF_Budget_FinalPayment]
                                       ([ObjectID]
                                       ,[ParentObjectID]
                                       ,[ParentPropertyName]
                                       ,[ParentIndex]
                                       ,[InstanceId]
                                       ,[Year]
                                       ,[Month]
                                       ,[UnitID]
                                       ,[UnitName]
                                       ,[MainSbjCode]
                                       ,[SubSbjCode]
                                       ,[SubjectCode]
                                       ,[Amount]
                                       ,[YearAmount]
                                       ,[YearRestAmount]
                                       ,[MonthAmount]
                                       ,[MonthRestAmount]
                                       ,[State]
                                       ,[CreatedTime]
                                       ,[CreatedBy]
                                       ,[ModifiedTime]
                                       ,[ModifiedBy])
                                 VALUES
                                       ('{0}'
                                       ,''
                                       ,''
                                       ,0
                                       ,'{1}'
                                       ,{2}
                                       ,{3}
                                       ,'{4}'
                                       ,'{5}'
                                       ,'{6}'
                                       ,''
                                       ,''
                                       ,0
                                       ,{8}
                                       ,{8}
                                       ,{7}
                                       ,{7}
                                       ,1
                                       ,getdate()
                                       ,'{9}'
                                       ,getdate()
                                       ,'{10}')";
                                sqlInsert = string.Format(sqlInsert, Guid.NewGuid(), dt.Rows[i]["ObjectID"].ToString(), dt.Rows[i]["Year"].ToString(), "3", dt.Rows[i]["DeptCode"].ToString(), dt.Rows[i]["DeptName"].ToString(), dt.Rows[i]["CostType"].ToString(), dt.Rows[i]["JanuaryCh"].ToString(), dt.Rows[i]["TotalCh"].ToString(), dt.Rows[i]["CreatedBy"].ToString(), dt.Rows[i]["CreatedBy"].ToString());
                                OThinker.H3.WorkSheet.AppUtility.Engine.EngineConfig.CommandFactory.CreateCommand().ExecuteNonQuery(sqlInsert);
                                break;
                            case 4:
                                sqlInsert = @"INSERT INTO [DSF_Budget_FinalPayment]
                                       ([ObjectID]
                                       ,[ParentObjectID]
                                       ,[ParentPropertyName]
                                       ,[ParentIndex]
                                       ,[InstanceId]
                                       ,[Year]
                                       ,[Month]
                                       ,[UnitID]
                                       ,[UnitName]
                                       ,[MainSbjCode]
                                       ,[SubSbjCode]
                                       ,[SubjectCode]
                                       ,[Amount]
                                       ,[YearAmount]
                                       ,[YearRestAmount]
                                       ,[MonthAmount]
                                       ,[MonthRestAmount]
                                       ,[State]
                                       ,[CreatedTime]
                                       ,[CreatedBy]
                                       ,[ModifiedTime]
                                       ,[ModifiedBy])
                                 VALUES
                                       ('{0}'
                                       ,''
                                       ,''
                                       ,0
                                       ,'{1}'
                                       ,{2}
                                       ,{3}
                                       ,'{4}'
                                       ,'{5}'
                                       ,'{6}'
                                       ,''
                                       ,''
                                       ,0
                                       ,{8}
                                       ,{8}
                                       ,{7}
                                       ,{7}
                                       ,1
                                       ,getdate()
                                       ,'{9}'
                                       ,getdate()
                                       ,'{10}')";
                                sqlInsert = string.Format(sqlInsert, Guid.NewGuid(), dt.Rows[i]["ObjectID"].ToString(), dt.Rows[i]["Year"].ToString(), "4", dt.Rows[i]["DeptCode"].ToString(), dt.Rows[i]["DeptName"].ToString(), dt.Rows[i]["CostType"].ToString(), dt.Rows[i]["JanuaryCh"].ToString(), dt.Rows[i]["TotalCh"].ToString(), dt.Rows[i]["CreatedBy"].ToString(), dt.Rows[i]["CreatedBy"].ToString());
                                OThinker.H3.WorkSheet.AppUtility.Engine.EngineConfig.CommandFactory.CreateCommand().ExecuteNonQuery(sqlInsert);
                                break;
                            case 5:
                                sqlInsert = @"INSERT INTO [DSF_Budget_FinalPayment]
                                       ([ObjectID]
                                       ,[ParentObjectID]
                                       ,[ParentPropertyName]
                                       ,[ParentIndex]
                                       ,[InstanceId]
                                       ,[Year]
                                       ,[Month]
                                       ,[UnitID]
                                       ,[UnitName]
                                       ,[MainSbjCode]
                                       ,[SubSbjCode]
                                       ,[SubjectCode]
                                       ,[Amount]
                                       ,[YearAmount]
                                       ,[YearRestAmount]
                                       ,[MonthAmount]
                                       ,[MonthRestAmount]
                                       ,[State]
                                       ,[CreatedTime]
                                       ,[CreatedBy]
                                       ,[ModifiedTime]
                                       ,[ModifiedBy])
                                 VALUES
                                       ('{0}'
                                       ,''
                                       ,''
                                       ,0
                                       ,'{1}'
                                       ,{2}
                                       ,{3}
                                       ,'{4}'
                                       ,'{5}'
                                       ,'{6}'
                                       ,''
                                       ,''
                                       ,0
                                       ,{8}
                                       ,{8}
                                       ,{7}
                                       ,{7}
                                       ,1
                                       ,getdate()
                                       ,'{9}'
                                       ,getdate()
                                       ,'{10}')";
                                sqlInsert = string.Format(sqlInsert, Guid.NewGuid(), dt.Rows[i]["ObjectID"].ToString(), dt.Rows[i]["Year"].ToString(), "5", dt.Rows[i]["DeptCode"].ToString(), dt.Rows[i]["DeptName"].ToString(), dt.Rows[i]["CostType"].ToString(), dt.Rows[i]["JanuaryCh"].ToString(), dt.Rows[i]["TotalCh"].ToString(), dt.Rows[i]["CreatedBy"].ToString(), dt.Rows[i]["CreatedBy"].ToString());
                                OThinker.H3.WorkSheet.AppUtility.Engine.EngineConfig.CommandFactory.CreateCommand().ExecuteNonQuery(sqlInsert);
                                break;
                            case 6:
                                sqlInsert = @"INSERT INTO [DSF_Budget_FinalPayment]
                                       ([ObjectID]
                                       ,[ParentObjectID]
                                       ,[ParentPropertyName]
                                       ,[ParentIndex]
                                       ,[InstanceId]
                                       ,[Year]
                                       ,[Month]
                                       ,[UnitID]
                                       ,[UnitName]
                                       ,[MainSbjCode]
                                       ,[SubSbjCode]
                                       ,[SubjectCode]
                                       ,[Amount]
                                       ,[YearAmount]
                                       ,[YearRestAmount]
                                       ,[MonthAmount]
                                       ,[MonthRestAmount]
                                       ,[State]
                                       ,[CreatedTime]
                                       ,[CreatedBy]
                                       ,[ModifiedTime]
                                       ,[ModifiedBy])
                                 VALUES
                                       ('{0}'
                                       ,''
                                       ,''
                                       ,0
                                       ,'{1}'
                                       ,{2}
                                       ,{3}
                                       ,'{4}'
                                       ,'{5}'
                                       ,'{6}'
                                       ,''
                                       ,''
                                       ,0
                                       ,{8}
                                       ,{8}
                                       ,{7}
                                       ,{7}
                                       ,1
                                       ,getdate()
                                       ,'{9}'
                                       ,getdate()
                                       ,'{10}')";
                                sqlInsert = string.Format(sqlInsert, Guid.NewGuid(), dt.Rows[i]["ObjectID"].ToString(), dt.Rows[i]["Year"].ToString(), "6", dt.Rows[i]["DeptCode"].ToString(), dt.Rows[i]["DeptName"].ToString(), dt.Rows[i]["CostType"].ToString(), dt.Rows[i]["JanuaryCh"].ToString(), dt.Rows[i]["TotalCh"].ToString(), dt.Rows[i]["CreatedBy"].ToString(), dt.Rows[i]["CreatedBy"].ToString());
                                OThinker.H3.WorkSheet.AppUtility.Engine.EngineConfig.CommandFactory.CreateCommand().ExecuteNonQuery(sqlInsert);
                                break;
                            case 7:
                                sqlInsert = @"INSERT INTO [DSF_Budget_FinalPayment]
                                       ([ObjectID]
                                       ,[ParentObjectID]
                                       ,[ParentPropertyName]
                                       ,[ParentIndex]
                                       ,[InstanceId]
                                       ,[Year]
                                       ,[Month]
                                       ,[UnitID]
                                       ,[UnitName]
                                       ,[MainSbjCode]
                                       ,[SubSbjCode]
                                       ,[SubjectCode]
                                       ,[Amount]
                                       ,[YearAmount]
                                       ,[YearRestAmount]
                                       ,[MonthAmount]
                                       ,[MonthRestAmount]
                                       ,[State]
                                       ,[CreatedTime]
                                       ,[CreatedBy]
                                       ,[ModifiedTime]
                                       ,[ModifiedBy])
                                 VALUES
                                       ('{0}'
                                       ,''
                                       ,''
                                       ,0
                                       ,'{1}'
                                       ,{2}
                                       ,{3}
                                       ,'{4}'
                                       ,'{5}'
                                       ,'{6}'
                                       ,''
                                       ,''
                                       ,0
                                       ,{8}
                                       ,{8}
                                       ,{7}
                                       ,{7}
                                       ,1
                                       ,getdate()
                                       ,'{9}'
                                       ,getdate()
                                       ,'{10}')";
                                sqlInsert = string.Format(sqlInsert, Guid.NewGuid(), dt.Rows[i]["ObjectID"].ToString(), dt.Rows[i]["Year"].ToString(), "7", dt.Rows[i]["DeptCode"].ToString(), dt.Rows[i]["DeptName"].ToString(), dt.Rows[i]["CostType"].ToString(), dt.Rows[i]["JanuaryCh"].ToString(), dt.Rows[i]["TotalCh"].ToString(), dt.Rows[i]["CreatedBy"].ToString(), dt.Rows[i]["CreatedBy"].ToString());
                                OThinker.H3.WorkSheet.AppUtility.Engine.EngineConfig.CommandFactory.CreateCommand().ExecuteNonQuery(sqlInsert);
                                break;
                            case 8:
                                sqlInsert = @"INSERT INTO [DSF_Budget_FinalPayment]
                                       ([ObjectID]
                                       ,[ParentObjectID]
                                       ,[ParentPropertyName]
                                       ,[ParentIndex]
                                       ,[InstanceId]
                                       ,[Year]
                                       ,[Month]
                                       ,[UnitID]
                                       ,[UnitName]
                                       ,[MainSbjCode]
                                       ,[SubSbjCode]
                                       ,[SubjectCode]
                                       ,[Amount]
                                       ,[YearAmount]
                                       ,[YearRestAmount]
                                       ,[MonthAmount]
                                       ,[MonthRestAmount]
                                       ,[State]
                                       ,[CreatedTime]
                                       ,[CreatedBy]
                                       ,[ModifiedTime]
                                       ,[ModifiedBy])
                                 VALUES
                                       ('{0}'
                                       ,''
                                       ,''
                                       ,0
                                       ,'{1}'
                                       ,{2}
                                       ,{3}
                                       ,'{4}'
                                       ,'{5}'
                                       ,'{6}'
                                       ,''
                                       ,''
                                       ,0
                                       ,{8}
                                       ,{8}
                                       ,{7}
                                       ,{7}
                                       ,1
                                       ,getdate()
                                       ,'{9}'
                                       ,getdate()
                                       ,'{10}')";
                                sqlInsert = string.Format(sqlInsert, Guid.NewGuid(), dt.Rows[i]["ObjectID"].ToString(), dt.Rows[i]["Year"].ToString(), "8", dt.Rows[i]["DeptCode"].ToString(), dt.Rows[i]["DeptName"].ToString(), dt.Rows[i]["CostType"].ToString(), dt.Rows[i]["JanuaryCh"].ToString(), dt.Rows[i]["TotalCh"].ToString(), dt.Rows[i]["CreatedBy"].ToString(), dt.Rows[i]["CreatedBy"].ToString());
                                OThinker.H3.WorkSheet.AppUtility.Engine.EngineConfig.CommandFactory.CreateCommand().ExecuteNonQuery(sqlInsert);
                                break;
                            case 9:
                                sqlInsert = @"INSERT INTO [DSF_Budget_FinalPayment]
                                       ([ObjectID]
                                       ,[ParentObjectID]
                                       ,[ParentPropertyName]
                                       ,[ParentIndex]
                                       ,[InstanceId]
                                       ,[Year]
                                       ,[Month]
                                       ,[UnitID]
                                       ,[UnitName]
                                       ,[MainSbjCode]
                                       ,[SubSbjCode]
                                       ,[SubjectCode]
                                       ,[Amount]
                                       ,[YearAmount]
                                       ,[YearRestAmount]
                                       ,[MonthAmount]
                                       ,[MonthRestAmount]
                                       ,[State]
                                       ,[CreatedTime]
                                       ,[CreatedBy]
                                       ,[ModifiedTime]
                                       ,[ModifiedBy])
                                 VALUES
                                       ('{0}'
                                       ,''
                                       ,''
                                       ,0
                                       ,'{1}'
                                       ,{2}
                                       ,{3}
                                       ,'{4}'
                                       ,'{5}'
                                       ,'{6}'
                                       ,''
                                       ,''
                                       ,0
                                       ,{8}
                                       ,{8}
                                       ,{7}
                                       ,{7}
                                       ,1
                                       ,getdate()
                                       ,'{9}'
                                       ,getdate()
                                       ,'{10}')";
                                sqlInsert = string.Format(sqlInsert, Guid.NewGuid(), dt.Rows[i]["ObjectID"].ToString(), dt.Rows[i]["Year"].ToString(), "9", dt.Rows[i]["DeptCode"].ToString(), dt.Rows[i]["DeptName"].ToString(), dt.Rows[i]["CostType"].ToString(), dt.Rows[i]["JanuaryCh"].ToString(), dt.Rows[i]["TotalCh"].ToString(), dt.Rows[i]["CreatedBy"].ToString(), dt.Rows[i]["CreatedBy"].ToString());
                                OThinker.H3.WorkSheet.AppUtility.Engine.EngineConfig.CommandFactory.CreateCommand().ExecuteNonQuery(sqlInsert);
                                break;
                            case 10:
                                sqlInsert = @"INSERT INTO [DSF_Budget_FinalPayment]
                                       ([ObjectID]
                                       ,[ParentObjectID]
                                       ,[ParentPropertyName]
                                       ,[ParentIndex]
                                       ,[InstanceId]
                                       ,[Year]
                                       ,[Month]
                                       ,[UnitID]
                                       ,[UnitName]
                                       ,[MainSbjCode]
                                       ,[SubSbjCode]
                                       ,[SubjectCode]
                                       ,[Amount]
                                       ,[YearAmount]
                                       ,[YearRestAmount]
                                       ,[MonthAmount]
                                       ,[MonthRestAmount]
                                       ,[State]
                                       ,[CreatedTime]
                                       ,[CreatedBy]
                                       ,[ModifiedTime]
                                       ,[ModifiedBy])
                                 VALUES
                                       ('{0}'
                                       ,''
                                       ,''
                                       ,0
                                       ,'{1}'
                                       ,{2}
                                       ,{3}
                                       ,'{4}'
                                       ,'{5}'
                                       ,'{6}'
                                       ,''
                                       ,''
                                       ,0
                                       ,{8}
                                       ,{8}
                                       ,{7}
                                       ,{7}
                                       ,1
                                       ,getdate()
                                       ,'{9}'
                                       ,getdate()
                                       ,'{10}')";
                                sqlInsert = string.Format(sqlInsert, Guid.NewGuid(), dt.Rows[i]["ObjectID"].ToString(), dt.Rows[i]["Year"].ToString(), "10", dt.Rows[i]["DeptCode"].ToString(), dt.Rows[i]["DeptName"].ToString(), dt.Rows[i]["CostType"].ToString(), dt.Rows[i]["JanuaryCh"].ToString(), dt.Rows[i]["TotalCh"].ToString(), dt.Rows[i]["CreatedBy"].ToString(), dt.Rows[i]["CreatedBy"].ToString());
                                OThinker.H3.WorkSheet.AppUtility.Engine.EngineConfig.CommandFactory.CreateCommand().ExecuteNonQuery(sqlInsert);
                                break;
                            case 11:
                                sqlInsert = @"INSERT INTO [DSF_Budget_FinalPayment]
                                       ([ObjectID]
                                       ,[ParentObjectID]
                                       ,[ParentPropertyName]
                                       ,[ParentIndex]
                                       ,[InstanceId]
                                       ,[Year]
                                       ,[Month]
                                       ,[UnitID]
                                       ,[UnitName]
                                       ,[MainSbjCode]
                                       ,[SubSbjCode]
                                       ,[SubjectCode]
                                       ,[Amount]
                                       ,[YearAmount]
                                       ,[YearRestAmount]
                                       ,[MonthAmount]
                                       ,[MonthRestAmount]
                                       ,[State]
                                       ,[CreatedTime]
                                       ,[CreatedBy]
                                       ,[ModifiedTime]
                                       ,[ModifiedBy])
                                 VALUES
                                       ('{0}'
                                       ,''
                                       ,''
                                       ,0
                                       ,'{1}'
                                       ,{2}
                                       ,{3}
                                       ,'{4}'
                                       ,'{5}'
                                       ,'{6}'
                                       ,''
                                       ,''
                                       ,0
                                       ,{8}
                                       ,{8}
                                       ,{7}
                                       ,{7}
                                       ,1
                                       ,getdate()
                                       ,'{9}'
                                       ,getdate()
                                       ,'{10}')";
                                sqlInsert = string.Format(sqlInsert, Guid.NewGuid(), dt.Rows[i]["ObjectID"].ToString(), dt.Rows[i]["Year"].ToString(), "11", dt.Rows[i]["DeptCode"].ToString(), dt.Rows[i]["DeptName"].ToString(), dt.Rows[i]["CostType"].ToString(), dt.Rows[i]["JanuaryCh"].ToString(), dt.Rows[i]["TotalCh"].ToString(), dt.Rows[i]["CreatedBy"].ToString(), dt.Rows[i]["CreatedBy"].ToString());
                                OThinker.H3.WorkSheet.AppUtility.Engine.EngineConfig.CommandFactory.CreateCommand().ExecuteNonQuery(sqlInsert);
                                break;
                            case 12:
                                sqlInsert = @"INSERT INTO [DSF_Budget_FinalPayment]
                                       ([ObjectID]
                                       ,[ParentObjectID]
                                       ,[ParentPropertyName]
                                       ,[ParentIndex]
                                       ,[InstanceId]
                                       ,[Year]
                                       ,[Month]
                                       ,[UnitID]
                                       ,[UnitName]
                                       ,[MainSbjCode]
                                       ,[SubSbjCode]
                                       ,[SubjectCode]
                                       ,[Amount]
                                       ,[YearAmount]
                                       ,[YearRestAmount]
                                       ,[MonthAmount]
                                       ,[MonthRestAmount]
                                       ,[State]
                                       ,[CreatedTime]
                                       ,[CreatedBy]
                                       ,[ModifiedTime]
                                       ,[ModifiedBy])
                                 VALUES
                                       ('{0}'
                                       ,''
                                       ,''
                                       ,0
                                       ,'{1}'
                                       ,{2}
                                       ,{3}
                                       ,'{4}'
                                       ,'{5}'
                                       ,'{6}'
                                       ,''
                                       ,''
                                       ,0
                                       ,{8}
                                       ,{8}
                                       ,{7}
                                       ,{7}
                                       ,1
                                       ,getdate()
                                       ,'{9}'
                                       ,getdate()
                                       ,'{10}')";
                                sqlInsert = string.Format(sqlInsert, Guid.NewGuid(), dt.Rows[i]["ObjectID"].ToString(), dt.Rows[i]["Year"].ToString(), "12", dt.Rows[i]["DeptCode"].ToString(), dt.Rows[i]["DeptName"].ToString(), dt.Rows[i]["CostType"].ToString(), dt.Rows[i]["JanuaryCh"].ToString(), dt.Rows[i]["TotalCh"].ToString(), dt.Rows[i]["CreatedBy"].ToString(), dt.Rows[i]["CreatedBy"].ToString());
                                OThinker.H3.WorkSheet.AppUtility.Engine.EngineConfig.CommandFactory.CreateCommand().ExecuteNonQuery(sqlInsert);
                                break;
                        }
                        #endregion
                    }
                }
            }
        }

        /// <summary>
        /// 开门费预算调整后，修改预算表数值
        /// </summary>
        /// <param name="instanceId"></param>
        [WebMethod]
        public void AdjustBudgetKaiMenFei(DateTime date,string deptid,string feiyongleixing,string amount) {

            string Year = date.Year.ToString();
            string Month = date.Month.ToString();

            string unitId = OThinker.H3.WorkSheet.AppUtility.Engine.Organization.GetUnit(deptid).Code;

//更新月金额
            string sqlMonth = string.Format(@"update DSF_Budget_FinalPayment set  MonthAmount = {4},MonthRestAmount= {4}
where Year='{0}' AND Month='{1}' AND UnitID='{2}' AND State =1 AND MainSbjCode='{3}' ", Year, Month, unitId, feiyongleixing, amount);

            //更新年度预算
            string sqlYear = string.Format(@" update DSF_Budget_FinalPayment set  YearAmount =(select SUM(MonthAmount) 
from DSF_Budget_FinalPayment 
where Year='{0}' AND UnitID='{1}' AND State =1 AND MainSbjCode='{2}' ),YearRestAmount=(select SUM(MonthAmount) from DSF_Budget_FinalPayment 
where Year='{0}' AND UnitID='{1}' AND State =1 AND MainSbjCode='{2}' )
where Year='{0}' AND UnitID='{1}' AND State =1 AND MainSbjCode='{2}' ", Year, unitId, feiyongleixing);

            //新增月金额
            string sqlIns = string.Format(@"INSERT INTO DSF_Budget_FinalPayment (ObjectID,InstanceId,Year,Month,UnitID,MainSbjCode,MonthAmount,MonthRestAmount,State) VALUES(NEWID(),NEWID(),'{0}','{1}','{2}','{3}',{4},{5},'1')", Year, Month, unitId, feiyongleixing, amount, amount);

            //查询是否存在该开门费，如果存在就更新，否则新增
            string sqlSel = string.Format(@"SELECT ObjectID FROM DSF_Budget_FinalPayment WHERE Year='{0}' AND Month='{1}' AND UnitID='{2}' AND State ='1' AND MainSbjCode='{3}'", Year, Month, unitId, feiyongleixing);
            DataTable dt = OThinker.H3.WorkSheet.AppUtility.Engine.EngineConfig.CommandFactory.CreateCommand().ExecuteDataTable(sqlSel);
            if (dt != null && dt.Rows.Count > 0)
            {
                OThinker.H3.WorkSheet.AppUtility.Engine.EngineConfig.CommandFactory.CreateCommand().ExecuteNonQuery(sqlMonth);
                OThinker.H3.WorkSheet.AppUtility.Engine.EngineConfig.CommandFactory.CreateCommand().ExecuteNonQuery(sqlYear);
            }
            else
            {
                OThinker.H3.WorkSheet.AppUtility.Engine.EngineConfig.CommandFactory.CreateCommand().ExecuteNonQuery(sqlIns);
            }
        }

        /// <summary>
        /// 预算外申请预算调整后，追加总额修改预算表数值
        /// </summary>
        /// <param name="instanceId"></param>
        [WebMethod]
        public void AdjustBudgetYuSuanWaiTiaozheng(DateTime date, string deptid, string feiyongleixing, string amount,string ajusttype)
        {
            if (ajusttype==null)
            {
                return;
            }
            
            string Year = date.Year.ToString();
            string Month = date.Month.ToString();

            deptid = GetSecondDept(deptid);

            string unitId = OThinker.H3.WorkSheet.AppUtility.Engine.Organization.GetUnit(deptid).Code;

            //更新年度预算 总额追加
            string sqlYear = @"UPDATE DSF_Budget_FinalPayment SET  MonthAmount = MonthAmount + @MonthAmount,MonthRestAmount = MonthRestAmount + @MonthRestAmount where Year = @Year AND Month = @Month AND UnitID = @UnitID AND State = 1 AND MainSbjCode = @MainSbjCode";
            
            OThinker.Data.Database.Parameter[] Parameters = new OThinker.Data.Database.Parameter[6];
            Parameters[0] = new OThinker.Data.Database.Parameter("Year", DbType.Int32, Year);
            Parameters[1] = new OThinker.Data.Database.Parameter("Month", DbType.Int32, Month);
            Parameters[2] = new OThinker.Data.Database.Parameter("UnitID", DbType.String, unitId);
            Parameters[3] = new OThinker.Data.Database.Parameter("MainSbjCode", DbType.String, feiyongleixing);
            Parameters[4] = new OThinker.Data.Database.Parameter("MonthAmount", DbType.Decimal, amount);
            Parameters[5] = new OThinker.Data.Database.Parameter("MonthRestAmount", DbType.Decimal, amount);

            if (ajusttype == "月间调整")
            {
                OThinker.Data.Database.Parameter[] Parameters1 = new OThinker.Data.Database.Parameter[5];
                Parameters1[0] = new OThinker.Data.Database.Parameter("UnitID", DbType.String, unitId);
                Parameters1[1] = new OThinker.Data.Database.Parameter("MainSbjCode", DbType.String, feiyongleixing);
                Parameters1[2] = new OThinker.Data.Database.Parameter("Year", DbType.Int32, Year);
                Parameters1[3] = new OThinker.Data.Database.Parameter("Month", DbType.Int32, Month);
                Parameters1[4] = new OThinker.Data.Database.Parameter("Amount", DbType.Decimal, amount);

                OThinker.H3.WorkSheet.AppUtility.Engine.EngineConfig.CommandFactory.CreateCommand().ExecuteProcedure("PR_YUEJIANTIAOZHENG", Parameters1);
            }
            else
            {
                OThinker.H3.WorkSheet.AppUtility.Engine.EngineConfig.CommandFactory.CreateCommand().ExecuteNonQuery(sqlYear, Parameters);
            }
        }

        /// <summary>
        /// 发起申请占用预算
        /// </summary>
        /// <param name="instanceId"></param>
        /// <param name="date"></param>
        /// <param name="unitId"></param>
        /// <param name="mainSbjCode"></param>
        /// <param name="amount"></param>
        /// <param name="userId"></param>
        [WebMethod]
        public void AddUsedBudget(string instanceId, DateTime date, string unitId, string mainSbjCode, decimal amount, string userId)
        {
            unitId = GetSecondDept(unitId);//转换部门ID为对应的二级部门ID
            string orgCode = string.Empty;
            string orgName = string.Empty;
            OThinker.Organization.OrganizationUnit org = OThinker.H3.WorkSheet.AppUtility.Engine.Organization.GetUnit(unitId) as OThinker.Organization.OrganizationUnit;
            if (org != null)
            {
                orgCode = org.Code;
                orgName = org.Name;
            }
            else
            {
                orgCode = unitId;
                orgName = unitId;
            }
            string sqlInsert = @"INSERT INTO [DSF_Budget_Use]
                                       ([ObjectID]
                                       ,[ParentIndex]
                                       ,[InstanceId]
                                       ,[Year]
                                       ,[Month]
                                       ,[UnitID]
                                       ,[UnitName]
                                       ,[MainSbjCode]
                                       ,[Amount]
                                       ,[State]
                                       ,[CreatedTime]
                                       ,[CreatedBy]
                                       ,[ModifiedTime]
                                       ,[ModifiedBy])
                                 VALUES
                                       ('{0}'
                                       ,0
                                       ,'{1}'
                                       ,{2}
                                       ,{3}
                                       ,'{4}'
                                       ,'{5}'
                                       ,'{6}'
                                       ,{7}
                                       ,'{8}'
                                       ,getdate()
                                       ,'{9}'
                                       ,getdate()
                                       ,'{10}')";
            string sqlUpdate = "UPDATE DSF_Budget_Use SET [Year] = {0},[Month] = {1},[UnitID] = '{2}',[MainSbjCode] = '{3}',[Amount] = {4} WHERE [InstanceId] = '{5}'";
            string sqlSelect = "SELECT * FROM DSF_Budget_Use WHERE [InstanceId] = '{0}'";

            sqlSelect = string.Format(sqlSelect, instanceId);
            sqlUpdate = string.Format(sqlUpdate, date.Year, date.Month, orgCode, mainSbjCode, amount, instanceId);
            sqlInsert = string.Format(sqlInsert, Guid.NewGuid(), instanceId, date.Year, date.Month, orgCode, orgName, mainSbjCode, amount, 1, userId, userId);
            DataTable dt = OThinker.H3.WorkSheet.AppUtility.Engine.EngineConfig.CommandFactory.CreateCommand().ExecuteDataTable(sqlSelect);
            if (dt != null && dt.Rows.Count > 0)
            {
                OThinker.H3.WorkSheet.AppUtility.Engine.EngineConfig.CommandFactory.CreateCommand().ExecuteNonQuery(sqlUpdate);
            }
            else
            {
                OThinker.H3.WorkSheet.AppUtility.Engine.EngineConfig.CommandFactory.CreateCommand().ExecuteNonQuery(sqlInsert);
            }
        }

        /// <summary>
        /// 实际使用预算
        /// </summary>
        /// <param name="instanceId"></param>
        /// <param name="date"></param>
        /// <param name="unitId"></param>
        /// <param name="mainSbjCode"></param>
        /// <param name="amount"></param>
        /// <param name="userId"></param>
        [WebMethod]
        public void UsedBudget(string instanceId,string PaymentInstanceId, decimal amount)
        {
            int _Month = System.DateTime.Now.Month;
            
            if (instanceId != null && instanceId != "")
            {
                string sqlUpdate = @"UPDATE dbo.[DSF_Budget_Use] SET [Amount] = {0},[Month] = {1},[PaymentInstanceId] = '{2}' WHERE [InstanceId] = '{3}' AND [State] = '1'";
                sqlUpdate = string.Format(sqlUpdate, amount, _Month, PaymentInstanceId, instanceId);
                
                OThinker.H3.WorkSheet.AppUtility.Engine.EngineConfig.CommandFactory.CreateCommand().ExecuteNonQuery(sqlUpdate);
            }
            else {
                string sqlUpdate = @"UPDATE dbo.[DSF_Budget_Use] SET [PaymentInstanceId] = '{0}' WHERE [InstanceId] = '{1}' AND [State] = '1'";
                sqlUpdate = string.Format(sqlUpdate, PaymentInstanceId, PaymentInstanceId);
                
                OThinker.H3.WorkSheet.AppUtility.Engine.EngineConfig.CommandFactory.CreateCommand().ExecuteNonQuery(sqlUpdate);
            }
        }

        /// <summary>
        /// 取消流程释放预算
        /// </summary>
        /// <param name="instanceId"></param>
        /// <param name="date"></param>
        /// <param name="unitId"></param>
        /// <param name="mainSbjCode"></param>
        /// <param name="amount"></param>
        /// <param name="userId"></param>
        [WebMethod]
        public void ReleaseUsedBudget(string instanceId)
        {
            string sqlUpdate = @"UPDATE dbo.[DSF_Budget_Use] SET [State] = '1' WHERE [InstanceId] = '{0}'";
            sqlUpdate = string.Format(sqlUpdate, instanceId);
            OThinker.H3.WorkSheet.AppUtility.Engine.EngineConfig.CommandFactory.CreateCommand().ExecuteNonQuery(sqlUpdate);
        }

        /// <summary>
        /// 发起申请占用预算(费用支付时)
        /// 若已经关联审批单，择不必重复占用预算
        /// 否则，发起时占用预算
        /// </summary>
        /// <param name="instanceId"></param>
        /// <param name="date"></param>
        /// <param name="unitId"></param>
        /// <param name="mainSbjCode"></param>
        /// <param name="amount"></param>
        /// <param name="userId"></param>
        [WebMethod]
        public void AddUsedBudget_NotRelat(string instanceId, DateTime date, string unitId, string mainSbjCode, decimal amount, string userId, string PaymentInstanceId)
        {
            unitId = GetSecondDept(unitId);//转换部门ID为对应的二级部门ID
            if (instanceId == null || instanceId == "")
            {
                string orgCode = string.Empty;
                string orgName = string.Empty;
                OThinker.Organization.OrganizationUnit org = OThinker.H3.WorkSheet.AppUtility.Engine.Organization.GetUnit(unitId) as OThinker.Organization.OrganizationUnit;
                if (org != null)
                {
                    orgCode = org.Code;
                    orgName = org.Name;
                }
                else
                {
                    orgCode = unitId;
                    orgName = unitId;
                }
                string sqlInsert = @"INSERT INTO [DSF_Budget_Use]
                                       ([ObjectID]
                                       ,[ParentIndex]
                                       ,[InstanceId]
                                       ,[Year]
                                       ,[Month]
                                       ,[UnitID]
                                       ,[UnitName]
                                       ,[MainSbjCode]
                                       ,[Amount]
                                       ,[State]
                                       ,[CreatedTime]
                                       ,[CreatedBy]
                                       ,[ModifiedTime]
                                       ,[ModifiedBy])
                                 VALUES
                                       ('{0}'
                                       ,0
                                       ,'{1}'
                                       ,{2}
                                       ,{3}
                                       ,'{4}'
                                       ,'{5}'
                                       ,'{6}'
                                       ,{7}
                                       ,'{8}'
                                       ,getdate()
                                       ,'{9}'
                                       ,getdate()
                                       ,'{10}')";
                string sqlUpdate = "UPDATE DSF_Budget_Use SET [Year] = {0},[Month] = {1},[UnitID] = '{2}',[MainSbjCode] = '{3}',[Amount] = {4} WHERE [InstanceId] = '{5}'";
                string sqlSelect = "SELECT * FROM DSF_Budget_Use WHERE [InstanceId] = '{0}'";

                sqlSelect = string.Format(sqlSelect, PaymentInstanceId);
                sqlUpdate = string.Format(sqlUpdate, date.Year, date.Month, orgCode, mainSbjCode, amount, PaymentInstanceId);
                sqlInsert = string.Format(sqlInsert, Guid.NewGuid(), PaymentInstanceId, date.Year, date.Month, orgCode, orgName, mainSbjCode, amount, 1, userId, userId);
                DataTable dt = OThinker.H3.WorkSheet.AppUtility.Engine.EngineConfig.CommandFactory.CreateCommand().ExecuteDataTable(sqlSelect);
                if (dt != null && dt.Rows.Count > 0)
                {
                    OThinker.H3.WorkSheet.AppUtility.Engine.EngineConfig.CommandFactory.CreateCommand().ExecuteNonQuery(sqlUpdate);
                }
                else
                {
                    OThinker.H3.WorkSheet.AppUtility.Engine.EngineConfig.CommandFactory.CreateCommand().ExecuteNonQuery(sqlInsert);
                }
                //sqlInsert = string.Format(sqlInsert, Guid.NewGuid(), PaymentInstanceId, date.Year, date.Month, orgCode, orgName, mainSbjCode, amount, 1, userId, userId);
                //OThinker.H3.WorkSheet.AppUtility.Engine.EngineConfig.CommandFactory.CreateCommand().ExecuteNonQuery(sqlInsert);
            }
        }

        /// <summary>
        /// 是否超预算，大于0是，0不是（费用申请）
        /// </summary>
        /// <param name="instanceId"></param>
        /// <param name="date"></param>
        /// <param name="unitId"></param>
        /// <param name="mainSbjCode"></param>
        /// <param name="amount"></param>
        /// <returns></returns>
        [WebMethod]
        public int IsOverBudget(DateTime date, string unitId, string mainSbjCode, decimal amount)
        {
            try
            {
                int rev= 0;
                int year = date.Year;
                int month = date.Month;

                unitId = GetSecondDept(unitId);//转换部门ID为对应的二级部门ID，子部门都对应到二级部门预算

                Organization.OrganizationUnit o = this.Engine.Organization.GetUnit(unitId) as Organization.OrganizationUnit;

                if (o != null)
                {
                    unitId = o.Code;
                }

                string sqlTotal = "select sum(MonthRestAmount) as count from dbo.DSF_Budget_FinalPayment where UnitID='{0}' and MainSbjCode='{1}' and Year={2} and Month<={3} and State='1'";
                sqlTotal = string.Format(sqlTotal, unitId, mainSbjCode, year, month);
                DataTable ot = OThinker.H3.WorkSheet.AppUtility.Engine.EngineConfig.CommandFactory.CreateCommand().ExecuteDataTable(sqlTotal);
                decimal total = 0;
                if (ot != null && ot.Rows.Count > 0)
                {
                    if (ot.Rows[0]["count"].ToString() != "")
                    {
                        total = Convert.ToDecimal(ot.Rows[0]["count"].ToString());
                    }
                    else
                    {
                        total = 0;
                    }
                }
                string sqlUsed = "select sum(Amount) as count from dbo.DSF_Budget_Use where UnitID='{0}' and MainSbjCode='{1}' and Year={2} and Month<={3} and State='1'";
                sqlUsed = string.Format(sqlUsed, unitId, mainSbjCode, year, month);
                DataTable ou = OThinker.H3.WorkSheet.AppUtility.Engine.EngineConfig.CommandFactory.CreateCommand().ExecuteDataTable(sqlUsed);
                decimal used = 0;
                if (ou != null && ou.Rows.Count > 0)
                {
                    if (ou.Rows[0]["count"].ToString() != "")
                    {
                        used = Convert.ToDecimal(ou.Rows[0]["count"].ToString());
                    }
                    else
                    {
                        used = 0;
                    }
                }
                if (amount + used > total)
                {
                    rev = Convert.ToInt32(this.ConvertToDecimal(amount) + this.ConvertToDecimal(used) - this.ConvertToDecimal(total));
                }

                return rev;
            }
            catch (Exception ex)
            {
                return 0;
            }
        }

        /// <summary>
        /// 是否超预算，大于0是，0不是(费用报销)
        /// </summary>
        /// <param name="instanceId"></param>
        /// <param name="date"></param>
        /// <param name="unitId"></param>
        /// <param name="mainSbjCode"></param>
        /// <param name="amount"></param>
        /// <returns></returns>
        [WebMethod]
        public int IsOverBudget_Expenses(DateTime date, string unitId, string mainSbjCode,decimal ApplyAmount, decimal ExpensesAmount,string type = "E")
        {
            try
            {
                int rev = 0;
                int year = date.Year;
                int month = date.Month;
                unitId = GetSecondDept(unitId);//转换部门ID为对应的二级部门ID

                Organization.OrganizationUnit o = this.Engine.Organization.GetUnit(unitId) as Organization.OrganizationUnit;

                if (o != null)
                {
                    unitId = o.Code;
                }

                string sqlTotal = "select sum(MonthRestAmount) as count from dbo.DSF_Budget_FinalPayment where UnitID='{0}' and MainSbjCode='{1}' and Year={2} and Month<={3} and State='1'";
                sqlTotal = string.Format(sqlTotal, unitId, mainSbjCode, year, month);
                DataTable ot = OThinker.H3.WorkSheet.AppUtility.Engine.EngineConfig.CommandFactory.CreateCommand().ExecuteDataTable(sqlTotal);
                decimal total = 0;
                if (ot != null && ot.Rows.Count > 0)
                {
                    if (ot.Rows[0]["count"].ToString() != "")
                    {
                        total = Convert.ToDecimal(ot.Rows[0]["count"].ToString());
                    }
                    else
                    {
                        total = 0;
                    }
                }
                string sqlUsed = "select sum(Amount) as count from dbo.DSF_Budget_Use where UnitID='{0}' and MainSbjCode='{1}' and Year={2} and Month<={3} and State='1'";
                sqlUsed = string.Format(sqlUsed, unitId, mainSbjCode, year, month);
                DataTable ou = OThinker.H3.WorkSheet.AppUtility.Engine.EngineConfig.CommandFactory.CreateCommand().ExecuteDataTable(sqlUsed);
                decimal used = 0;
                if (ou != null && ou.Rows.Count > 0)
                {
                    if (ou.Rows[0]["count"].ToString() != "")
                    {
                        used = Convert.ToDecimal(ou.Rows[0]["count"].ToString());
                    }
                    else
                    {
                        used = 0;
                    }
                }
                if (type == "S")
                {
                    //判断费用报销的时候，把费用申请占用的金额减去
                    if (ExpensesAmount + this.ConvertToDecimal(used) - this.ConvertToDecimal(ApplyAmount) > total)
                    {
                        rev = Convert.ToInt32(ExpensesAmount + this.ConvertToDecimal(used) - this.ConvertToDecimal(ApplyAmount) - total);
                    }
                }
                else
                {
                    if (used > total)
                    {
                        rev = Convert.ToInt32(this.ConvertToDecimal(used) - total);
                    }
                }
                return rev;
            }
            catch (Exception ex)
            {
                return 0;
            }
        }

        //数字转换方法
        public decimal ConvertToDecimal(Object targetValue)
        {
            if (targetValue == DBNull.Value || targetValue == null)
            {
                return 0M;
            }

            decimal result = 0M;
            decimal.TryParse(targetValue.ToString().Replace(",", ""), out result);

            return result;
        }

        /// <summary>
        /// 增加采购预算
        /// </summary>
        /// <param name="instanceId"></param>
        [WebMethod]
        public void SetPurchaseFinal(string instanceId)
        {
            DataTable dt = new DataTable();
            string sqltext = "select a.PurchaseType,a.ProductName,a.NeedNum,a.UnitPrice,a.NeedTime,b.DSFDepartment,b.CreatedBy,c.ObjectID,d.Name from I_PurchaseBudget a inner join I_PurchaseManage b on a.ParentObjectID=b.ObjectID inner join OT_InstanceContext c on b.ObjectID=c.BizObjectId inner join OT_OrganizationUnit d on b.DSFDepartment=d.ObjectID where c.ObjectID='{0}'";
            sqltext = string.Format(sqltext, instanceId);
            dt = OThinker.H3.WorkSheet.AppUtility.Engine.EngineConfig.CommandFactory.CreateCommand().ExecuteDataTable(sqltext);
            if (dt != null && dt.Rows.Count > 0)
            {
                for (int i = 0; i < dt.Rows.Count; i++)
                {
                    string sqlInsert = @"INSERT INTO [H3Cloud].[dbo].[DSF_Budget_Purchase]
                                       ([ObjectID]
                                       ,[ParentObjectID]
                                       ,[ParentPropertyName]
                                       ,[ParentIndex]
                                       ,[InstanceId]
                                       ,[NeedTime]
                                       ,[UnitID]
                                       ,[UnitName]
                                       ,[PurchaseType]
                                       ,[ProductName]
                                       ,[UnitPrice]
                                       ,[NeedNum]
                                       ,[State]
                                       ,[CreatedTime]
                                       ,[CreatedBy]
                                       ,[ModifiedTime]
                                       ,[ModifiedBy])
                                 VALUES
                                       ('{0}'
                                       ,''
                                       ,''
                                       ,0
                                       ,'{1}'
                                       ,'{2}'
                                       ,'{3}'
                                       ,'{4}'
                                       ,'{5}'
                                       ,'{6}'
                                       ,{7}
                                       ,{8}
                                       ,1
                                       ,getdate()
                                       ,'{9}'
                                       ,getdate()
                                       ,'{10}')";
                    sqlInsert = string.Format(sqlInsert, Guid.NewGuid(), dt.Rows[i]["ObjectID"].ToString(), dt.Rows[i]["NeedTime"].ToString(), dt.Rows[i]["DSFDepartment"].ToString(), dt.Rows[i]["Name"].ToString().Trim(), dt.Rows[i]["PurchaseType"].ToString(), dt.Rows[i]["ProductName"].ToString(), dt.Rows[i]["UnitPrice"].ToString(), dt.Rows[i]["NeedNum"].ToString(), dt.Rows[i]["CreatedBy"].ToString(), dt.Rows[i]["CreatedBy"].ToString());
                    OThinker.H3.WorkSheet.AppUtility.Engine.EngineConfig.CommandFactory.CreateCommand().ExecuteNonQuery(sqlInsert);

                }
            }
        }

        /// <summary>
        /// 是否超采购预算，0不超，1超
        /// </summary>
        [WebMethod]
        public string IsOverPurchase(string unitid, string productname, string unitprice)
        {
            string rev = "1";
            string sqltext = "select count(*) from dbo.DSF_Budget_Purchase where state=1 and unitid='{0}' and productname='{1}' and unitprice>={2}";
            sqltext = string.Format(sqltext, unitid, productname, unitprice);

            int i = Convert.ToInt32(OThinker.H3.WorkSheet.AppUtility.Engine.EngineConfig.CommandFactory.CreateCommand().ExecuteScalar(sqltext));
            if (i > 0)
            {
                rev = "0";
            }
            return rev;
        }

        // <summary>
        /// 更新审批状态  出差申请
        /// </summary>
        [WebMethod]
        public void UpdateBusinessTravelStatus(string InstanceId)
        {
            string sqlUpdate = @"UPDATE dbo.[I_BusinessTravel] SET [IsCompeleted] = 1 WHERE [ObjectID] = '{0}'";
            sqlUpdate = string.Format(sqlUpdate, InstanceId);
            OThinker.H3.WorkSheet.AppUtility.Engine.EngineConfig.CommandFactory.CreateCommand().ExecuteNonQuery(sqlUpdate);
        }

        // <summary>
        /// 更新审批状态  事务呈批
        /// </summary>
        [WebMethod]
        public void UpdateAffairApprovalStatus(string InstanceId)
        {
            string sqlUpdate = @"UPDATE dbo.[I_AffairApproval] SET [IsCompeleted] = 1 WHERE [ObjectID] = '{0}'";
            sqlUpdate = string.Format(sqlUpdate, InstanceId);
            OThinker.H3.WorkSheet.AppUtility.Engine.EngineConfig.CommandFactory.CreateCommand().ExecuteNonQuery(sqlUpdate);
        }

        // <summary>
        /// 更新审批状态  借款申请
        /// </summary>
        [WebMethod]
        public void UpdateLoanApplyStatus(string InstanceId)
        {
            string sqlUpdate = @"UPDATE dbo.[I_LoanApply] SET [IsCompeleted] = 1 WHERE [ObjectID] = '{0}'";
            sqlUpdate = string.Format(sqlUpdate, InstanceId);
            OThinker.H3.WorkSheet.AppUtility.Engine.EngineConfig.CommandFactory.CreateCommand().ExecuteNonQuery(sqlUpdate);
        }

        // <summary>
        /// 更新审批状态  业务招待申请
        /// </summary>
        [WebMethod]
        public void UpdateEntertainApplyStatus(string InstanceId)
        {
            string sqlUpdate = @"UPDATE dbo.[I_EntertainApply] SET [IsCompeleted] = 1 WHERE [ObjectID] = '{0}'";
            sqlUpdate = string.Format(sqlUpdate, InstanceId);
            OThinker.H3.WorkSheet.AppUtility.Engine.EngineConfig.CommandFactory.CreateCommand().ExecuteNonQuery(sqlUpdate);
        }

        // <summary>
        /// 更新审批状态  合同会审
        /// </summary>
        [WebMethod]
        public void UpdateContractAuditingStatus(string InstanceId)
        {
            string sqlUpdate = @"UPDATE dbo.[I_ContractAuditing] SET [IsCompeleted] = 1 WHERE [ObjectID] = '{0}'";
            sqlUpdate = string.Format(sqlUpdate, InstanceId);
            OThinker.H3.WorkSheet.AppUtility.Engine.EngineConfig.CommandFactory.CreateCommand().ExecuteNonQuery(sqlUpdate);
        }

        // <summary>
        /// 更新审批状态  离职
        /// </summary>
        [WebMethod]
        public void UpdateQuitFlowStatus(string InstanceId, string ActivityCode)
        {
            int Status = ActivityCode == "Activity21" ? 1 : ActivityCode == "Activity28" ? 2 : 0;
            string sqlUpdate = @"UPDATE dbo.[I_QuitFlow] SET [Status] = {0} WHERE [ObjectID] = '{1}'";
            sqlUpdate = string.Format(sqlUpdate, Status, InstanceId);
            OThinker.H3.WorkSheet.AppUtility.Engine.EngineConfig.CommandFactory.CreateCommand().ExecuteNonQuery(sqlUpdate);
        }

        // <summary>
        /// 是否副总裁发起
        /// </summary>
        [WebMethod]
        public string getPost(string UserID)
        {
            string IsVice = "N";
            
            string sqltext = @" select op.JobCode from dbo.OT_User as us
                                left join OT_GroupChild as gc on us.ObjectID=gc.ChildID
                                left join dbo.OT_OrgPost as op on gc.ParentObjectID = op.ObjectID
                                where us.ObjectID = '{0}'";
            sqltext = string.Format(sqltext,UserID);
            
            string JobCode = Convert.ToString(OThinker.H3.WorkSheet.AppUtility.Engine.EngineConfig.CommandFactory.CreateCommand().ExecuteScalar(sqltext));
            
            if (JobCode.Contains("副总裁"))
            {
                IsVice = "Y";
            }
            return IsVice;
        }

        // <summary>
        /// 部门总以及以上
        /// </summary>
        [WebMethod]
        public int getPost1(string UserID)
        {
            int IsVice = 0;

            string sqltext = @" select op.JobCode from dbo.OT_User as us
                                left join OT_GroupChild as gc on us.ObjectID=gc.ChildID
                                left join dbo.OT_OrgPost as op on gc.ParentObjectID = op.ObjectID
                                where us.ObjectID = '{0}'";
            sqltext = string.Format(sqltext, UserID);

            string JobCode = Convert.ToString(OThinker.H3.WorkSheet.AppUtility.Engine.EngineConfig.CommandFactory.CreateCommand().ExecuteScalar(sqltext));

            if (JobCode.Contains("总裁") || JobCode == "总经理")
            {
                IsVice = 1;
            }
            return IsVice;
        }

        /// <summary>
        /// 采购预算情况
        /// </summary>
        [WebMethod]
        public string HavePurchase(string unitid, string productname, string unitprice, string neednum,string needtime)
        {
            string rev = "预算充足";
            //string sqltext = "select count(*) from dbo.DSF_Budget_Purchase where state=1 and unitid='{0}' and productname='{1}' and (unitprice>={2} or NeedNum>={3})";
            //sqltext = string.Format(sqltext, unitid, productname, unitprice, neednum);

            //int i = Convert.ToInt32(OThinker.H3.WorkSheet.AppUtility.Engine.EngineConfig.CommandFactory.CreateCommand().ExecuteScalar(sqltext));
            //if (i > 0)
            //{
            //    rev = "预算充足";
            //}
            OThinker.H3.WorkSheet.AppUtility.Engine.LogWriter.Write(unitid + "-" + productname + "-" + unitprice + "-" + neednum + "-" + needtime);
            //需求日期的年份和预算月份的年份对应
            string needYear = Convert.ToDateTime(needtime).Year.ToString();

            string sqltext = "SELECT ISNULL(unitprice,0) AS unitprice,ISNULL(NeedNum,0) AS NeedNum FROM dbo.DSF_Budget_Purchase WHERE state=1 and unitid='{0}' and productname='{1}' and DATEPART(yyyy,NeedTime) ="+needYear;
            sqltext = string.Format(sqltext, unitid, productname);

            DataTable dt = OThinker.H3.WorkSheet.AppUtility.Engine.EngineConfig.CommandFactory.CreateCommand().ExecuteDataTable(sqltext);
            if (dt != null && dt.Rows.Count > 0)
            {
                decimal _unitprice = Convert.ToDecimal(unitprice) - Convert.ToDecimal(dt.Rows[0]["unitprice"]);
                decimal _neednum = Convert.ToDecimal(neednum) - Convert.ToDecimal(dt.Rows[0]["NeedNum"]);

                if (_unitprice > 0)
                {
                    rev = "超过采购单价" + _unitprice + "元；";
                }
                if (Convert.ToDecimal(neednum) > Convert.ToDecimal(dt.Rows[0]["NeedNum"]))
                {
                    if (rev == "预算充足") 
                    {
                        rev = "";
                    }
                    rev += needYear+"年超过采购数量" + _neednum + "个/台；";
                }
            }
            else {
                rev = "采购物品不在预算范围内。";
            }
            return rev;
        }

        /// <summary>
        /// 获取归口部门
        /// </summary>
        [WebMethod]
        public string GetChargeDept(string productname)
        {
            string rev = "";
            string code = "100060";
            List<string> list = new List<string>();
            string sqlFlow = "select * from ot_enumerablemetadata t where t.category='归口人事部'";
            DataTable dtFlow = OThinker.H3.WorkSheet.AppUtility.Engine.EngineConfig.CommandFactory.CreateCommand().ExecuteDataTable(sqlFlow);
            if (dtFlow != null && dtFlow.Rows.Count > 0)
            {
                for (int i = 0; i < dtFlow.Rows.Count; i++)
                {
                    list.Add(dtFlow.Rows[i]["Code"].ToString());
                }
            }
            if (list.Contains(productname))
            {
                code = "100120";
            }

            string sqltext = "select objectid from OT_OrganizationUnit where code='{0}'";
            sqltext = string.Format(sqltext, code);
    
            rev = OThinker.H3.WorkSheet.AppUtility.Engine.EngineConfig.CommandFactory.CreateCommand().ExecuteScalar(sqltext).ToString();

            return rev;
        }

        /// <summary>
        /// 获取合同单号
        /// </summary>
        [WebMethod]
        public string GetContractNumber(string ObjectID)
        {
            string ContractNumber = string.Empty;
            DateTime a = System.DateTime.Now;
            string sql = "SELECT ISNULL(ContractNO,'') AS ContractNO FROM I_ContractAuditing WHERE ObjectID = '{0}'";
            sql = string.Format(sql,ObjectID);
            DataTable dt = OThinker.H3.WorkSheet.AppUtility.Engine.EngineConfig.CommandFactory.CreateCommand().ExecuteDataTable(sql);
            if (dt.Rows[0]["ContractNO"].ToString() == "")
            {
                sql = @"DECLARE @SNumber int

                        select @SNumber = MAX(ISNULL(SerialNumber,0)) from dbo.I_SerialNumber where SerialNumberType = '合同会审' and YEAR = @Year and Month = @Month and Day = @Day
                        set @SNumber = isnull(@SNumber,0) + 1

                        insert into dbo.I_SerialNumber(ObjectID,SerialNumber,SerialNumberType,Year,Month,Day,CreatedTime) values(NEWID(),@SNumber,'合同会审',@Year,@Month,@Day,GETDATE())

                        select @SNumber as SerialNumber";

                OThinker.Data.Database.Parameter[] Parameters = new OThinker.Data.Database.Parameter[3];
                Parameters[0] = new OThinker.Data.Database.Parameter("Year", DbType.Int32, a.Year);
                Parameters[1] = new OThinker.Data.Database.Parameter("Month", DbType.Int32, a.Month);
                Parameters[2] = new OThinker.Data.Database.Parameter("Day", DbType.Int32, a.Day);

                dt = OThinker.H3.WorkSheet.AppUtility.Engine.EngineConfig.CommandFactory.CreateCommand().ExecuteDataTable(sql, Parameters);
                ContractNumber = "DSF" + a.ToString("yyyyMMdd") + dt.Rows[0]["SerialNumber"].ToString().PadLeft(4, '0');

            }
            else
            {
                ContractNumber = dt.Rows[0]["ContractNO"].ToString();
            }

            return ContractNumber;
        }

        /// <summary>
        /// 发送邮件提醒
        /// </summary>
        [WebMethod]
        public void SendMailNotice()
        {
            try
            {
                #region "票据是否完整，发送给财务部邮箱  finance@dashuf.com，每个月25号发送"

                string sqltext = @"select a.*,b.WorkflowVersion,b.WorkflowCode,b.SequenceNo,c.InstanceId,c.ObjectID as workitemid,d.Name as OriginatorName from I_PaymentApply a 
inner join OT_InstanceContext b on a.ObjectID=b.BizObjectId 
inner join OT_WorkItem c on b.ObjectID=c.InstanceId 
inner join OT_User  d on a.CreatedBy = d.ObjectID
where a.HaveNotes='无' and b.State=2 and c.ActivityCode='SendEmailAct' and (c.State=1 or c.State=0)";

                DataTable dt = OThinker.H3.WorkSheet.AppUtility.Engine.EngineConfig.CommandFactory.CreateCommand().ExecuteDataTable(sqltext);
                if (dt != null && dt.Rows.Count > 0)
                {
                    //票据提醒发送给财务公共邮箱
                    string ReceiveAddress = "finance@dashuf.com"; // OThinker.H3.WorkSheet.AppUtility.Engine.Organization.GetUserEmail(dt.Rows[0]["CreatedBy"].ToString());

                    System.Text.StringBuilder sbContent = new System.Text.StringBuilder();
                    sbContent.Append("<div>");
                    sbContent.Append("<table style=\"width: 600px;border-collapse: collapse;border: 1px solid #A5A5A8;\"><tbody>");

                    for (int i = 0; i < dt.Rows.Count; i++)
                    {
                        if (i == 0)
                        {
                            //表头
                            sbContent.Append("<tr>");
                            sbContent.Append("<td style='border-right: 1px solid #A5A5A8; border-bottom: 1px solid #A5A5A8;background:#ee4c50'>流水号</td>");
                            sbContent.Append("<td style='border-right: 1px solid #A5A5A8; border-bottom: 1px solid #A5A5A8;background:#ee4c50'>发起人</td>");
                            sbContent.Append("<td style='border-right: 1px solid #A5A5A8; border-bottom: 1px solid #A5A5A8;background:#ee4c50'>发起时间</td>");
                            sbContent.Append("<td style='border-right: 1px solid #A5A5A8; border-bottom: 1px solid #A5A5A8;background:#ee4c50'>票据金额</td>");
                            sbContent.Append("</tr>");
                        }

                        sbContent.Append("<tr>");
                        string url = "http://bpm.dashuf.com/Portal/InstanceSheets.aspx?InstanceId=" + dt.Rows[i]["InstanceId"].ToString();
                        sbContent.Append("<td style='border-right: 1px solid #A5A5A8; border-bottom: 1px solid #A5A5A8;'> <a href='" + url + "'>" + dt.Rows[i]["SequenceNo"].ToString() + "</a></td>");
                        sbContent.Append("<td style='border-right: 1px solid #A5A5A8; border-bottom: 1px solid #A5A5A8;'>" + dt.Rows[i]["OriginatorName"].ToString() + "</td>");
                        sbContent.Append("<td style='border-right: 1px solid #A5A5A8; border-bottom: 1px solid #A5A5A8;'>" + dt.Rows[i]["CreatedTime"].ToString() + "</td>");
                        sbContent.Append("<td style='border-right: 1px solid #A5A5A8; border-bottom: 1px solid #A5A5A8;'>" + double.Parse(dt.Rows[i]["Amount"].ToString()).ToString("0.00") + "</td>");
                        sbContent.Append("</tr>");

                    }

                    sbContent.Append("</tbody></table>");
                    sbContent.Append("</div>");

                    //每个月25号发送 10点发送
                    if (DateTime.Now.Day == 25 && DateTime.Now.Hour == 10) 
                    { 
                        OThinker.H3.Notification.Notification notice = new OThinker.H3.Notification.Notification
                                (OThinker.H3.Notification.NotifyType.Email,
                                null,
                                dt.Rows[0]["CreatedBy"].ToString(),
                                ReceiveAddress,
                                dt.Rows[0]["WorkflowCode"].ToString(),
                                Convert.ToInt32(dt.Rows[0]["WorkflowVersion"].ToString()),
                                dt.Rows[0]["InstanceId"].ToString(),
                                "出纳跟进发票提醒",
                                sbContent.ToString(),
                                dt.Rows[0]["workitemid"].ToString()
                                );
                        OThinker.H3.WorkSheet.AppUtility.Engine.Notifier.Notify(notice);
                    }
                }

                #endregion

                #region "支付提醒,付款前三天开始每天10点提醒"

                //只查询差三天就需要付款的流程

                int day = 3;

                //查找流程ID 
                string sqlInstanceIds = string.Format(@"select distinct c.ObjectID as InstanceID from I_PayNotice a 
                inner join I_PayDate b on a.ObjectID=b.ParentObjectID 
                inner join OT_InstanceContext c on a.ObjectID=c.BizObjectId
                inner join OT_User d  on d.ObjectID =a.CreatedBy
                where {0}>=DateDIFF(day,GETDATE(),b.PayDate) AND 0<= DateDIFF(day,GETDATE(),b.PayDate)", day);

                string sqlPay = @"select a.createdby,a.PurNumber,b.PayDate,b.Amount,a.ContractName,a.OtherNmae, c.SequenceNo,c.ObjectID as InstanceId,c.ObjectID as workItemID,c.WorkflowCode,c.WorkflowVersion,d.Name as OriginatorName from I_PayNotice a 
                inner join I_PayDate b on a.ObjectID=b.ParentObjectID 
                inner join OT_InstanceContext c on a.ObjectID=c.BizObjectId
                inner join OT_User d  on d.ObjectID =a.CreatedBy
                where c.ObjectID='{0}'";
                DataTable dtInstance = OThinker.H3.WorkSheet.AppUtility.Engine.EngineConfig.CommandFactory.CreateCommand().ExecuteDataTable(sqlInstanceIds);
                if (dtInstance != null && dtInstance.Rows.Count > 0)
                {
                    foreach (DataRow dr in dtInstance.Rows)
                    {
                        string instanceID = dr["InstanceID"].ToString();
                        string sql = string.Format(sqlPay, instanceID);
                        DataTable dtPay = OThinker.H3.WorkSheet.AppUtility.Engine.EngineConfig.CommandFactory.CreateCommand().ExecuteDataTable(sql);

                        //<div>
                        //<table style="width: 100%;border-collapse: collapse;border: 1px solid #A5A5A8;"><tbody>
                        //<tr>
                        //<td width="12%">发起人</td><td colspan="2">{Originator.UserName}</td>
                        //<td width="12%">发起时间</td>
                        //<td colspan="2">{OriginateDate}</td></tr>
                        //</tbody></table>
                        //</div>

                        if (dtPay != null && dtPay.Rows.Count > 0)
                        {
                            string ReceiveAddress = OThinker.H3.WorkSheet.AppUtility.Engine.Organization.GetUserEmail(dt.Rows[0]["CreatedBy"].ToString());
                            string contanctName = dtPay.Rows[0]["ContractName"].ToString();

                            System.Text.StringBuilder sbContent = new System.Text.StringBuilder();
                            sbContent.Append("<div>");
                            sbContent.Append("<table style=\"width: 600px;border-collapse: collapse;border: 1px solid #A5A5A8;\"><tbody>");

                            for (int i = 0; i < dtPay.Rows.Count; i++)
                            {
                                if (i == 0)
                                {
                                    sbContent.Append("<tr>");
                                    string url = "http://bpm.dashuf.com/Portal/InstanceSheets.aspx?InstanceId=" + instanceID;
                                    sbContent.Append("<td style='border-right: 1px solid #A5A5A8; border-bottom: 1px solid #A5A5A8;background:#ddd'>流水号</td><td style='border-right: 1px solid #A5A5A8; border-bottom: 1px solid #A5A5A8;'><a href='" + url + "'>" + dtPay.Rows[0]["SequenceNo"].ToString() + "</a></td>");
                                    sbContent.Append("<td style='border-right: 1px solid #A5A5A8; border-bottom: 1px solid #A5A5A8;background:#ddd'>合同名称</td><td style='border-right: 1px solid #A5A5A8; border-bottom: 1px solid #A5A5A8;'>" + dtPay.Rows[0]["ContractName"].ToString() + "</td>");
                                    sbContent.Append("</tr>");
                                    sbContent.Append("<tr>");
                                    sbContent.Append("<td style='border-right: 1px solid #A5A5A8; border-bottom: 1px solid #A5A5A8;background:#ddd'>对方名称</td><td style='border-right: 1px solid #A5A5A8; border-bottom: 1px solid #A5A5A8;'>" + dtPay.Rows[0]["OtherNmae"].ToString() + "</td>");
                                    sbContent.Append("<td style='border-right: 1px solid #A5A5A8; border-bottom: 1px solid #A5A5A8;background:#ddd'></td><td style='border-right: 1px solid #A5A5A8; border-bottom: 1px solid #A5A5A8;'></td>");
                                    sbContent.Append("</tr>");

                                    sbContent.Append("<tr>");
                                    sbContent.Append("<td colspan='4' style='border-right: 1px solid #A5A5A8; border-bottom: 1px solid #A5A5A8;'>");
                                    sbContent.Append("<table style=\"width: 100%;border-collapse: collapse;border: 1px solid #A5A5A8;\"><tbody>");

                                    //表头
                                    sbContent.Append("<tr>");
                                    sbContent.Append("<td style='border-right: 1px solid #A5A5A8; border-bottom: 1px solid #A5A5A8;background:#ee4c50'>序号</td>");
                                    sbContent.Append("<td style='border-right: 1px solid #A5A5A8; border-bottom: 1px solid #A5A5A8;background:#ee4c50'>付款时间</td>");
                                    sbContent.Append("<td style='border-right: 1px solid #A5A5A8; border-bottom: 1px solid #A5A5A8;background:#ee4c50'>付款金额</td>");
                                    sbContent.Append("</tr>");
                                }
                                sbContent.Append("<td style='border-right: 1px solid #A5A5A8; border-bottom: 1px solid #A5A5A8;'>" + (i + 1).ToString() + "</td>");
                                sbContent.Append("<td style='border-right: 1px solid #A5A5A8; border-bottom: 1px solid #A5A5A8;'>" + DateTime.Parse(dtPay.Rows[i]["PayDate"].ToString()).ToString("yyyy-MM-dd") + "</td>");
                                sbContent.Append("<td style='border-right: 1px solid #A5A5A8; border-bottom: 1px solid #A5A5A8;'>" + double.Parse(dtPay.Rows[i]["Amount"].ToString()).ToString("0.00") + "</td>");
                                sbContent.Append("</tr>");
                            }
                            string createBy = dtPay.Rows[0]["CreatedBy"].ToString();
                            string workflowCode = dtPay.Rows[0]["WorkflowCode"].ToString();
                            int workflowVersion = Convert.ToInt32(dt.Rows[0]["WorkflowVersion"].ToString());

                            sbContent.Append("</tbody></table>");
                            sbContent.Append("</td>");
                            sbContent.Append("</tr>");
                            sbContent.Append("</tbody></table>");
                            sbContent.Append("</div>");

                            //每天10点发送邮件
                            if (DateTime.Now.Hour == 10) 
                            { 
                                OThinker.H3.Notification.Notification notice = new OThinker.H3.Notification.Notification
                                       (OThinker.H3.Notification.NotifyType.Email,
                                       null,
                                       dtPay.Rows[0]["CreatedBy"].ToString(),
                                       ReceiveAddress,
                                       dtPay.Rows[0]["WorkflowCode"].ToString(),
                                       Convert.ToInt32(dt.Rows[0]["WorkflowVersion"].ToString()),
                                       dtPay.Rows[0]["InstanceId"].ToString(),
                                       contanctName + "支付提醒",
                                       sbContent.ToString(),
                                       dtPay.Rows[0]["workitemid"].ToString()
                                       );

                                OThinker.H3.WorkSheet.AppUtility.Engine.Notifier.Notify(notice);
                            }
                        }
                    }
                }

                #endregion
               
                
                #region "员工生日提醒"

                //查询是否有当天生日的员工
                string sqlSel = "SELECT ObjectID,ISNULL(Name,'') AS Name,ISNULL(Email,'') AS Email FROM OT_User WHERE   DATEPART(month,Birthday)= DATEPART(month,getdate()) AND   DATEPART(day,Birthday)= DATEPART(day,getdate())";

                DataTable dtUser = OThinker.H3.WorkSheet.AppUtility.Engine.EngineConfig.CommandFactory.CreateCommand().ExecuteDataTable(sqlSel);

                if (dtUser != null && dtUser.Rows.Count > 0)
                {
                    for (int i = 0; i < dtUser.Rows.Count; i++)
                    {
                        System.Text.StringBuilder sbContent = new System.Text.StringBuilder();
                        sbContent.Append("<div style=\"width: 526px;height:581px;background:url(http://bpm.dashuf.com/Portal/WFRes/images/GreetingCard.png)\">");
                        sbContent.Append("<div style=\"position:absolute;top:64px;left:103px\">" + dtUser.Rows[i]["Name"].ToString() + "</div>");
                        sbContent.Append("</div>");

                        int sendhour = 10; //10点钟发送一次，间隔时间为1小时轮询一次
                        if (DateTime.Now.Hour==sendhour)
                        {
                            OThinker.H3.Notification.Notification notice = new OThinker.H3.Notification.Notification
                                   (OThinker.H3.Notification.NotifyType.Email,
                                   null,
                                   dtUser.Rows[i]["ObjectID"].ToString(),
                                   dtUser.Rows[i]["Email"].ToString(),
                                   string.Empty,
                                   0,
                                   string.Empty,
                                   "亲爱的" + dtUser.Rows[i]["Name"].ToString() + "，生日快乐！",
                                   sbContent.ToString(),
                                   string.Empty
                                   );

                            OThinker.H3.WorkSheet.AppUtility.Engine.Notifier.Notify(notice);
                        }
                    }
                }

                #endregion
            }
            catch (Exception ex)
            {
                OThinker.H3.WorkSheet.AppUtility.Engine.LogWriter.Write("发送邮件提醒出错：" + ex.Message);
            }
        }


    }
}